/*!
 * Name          : steelseries.js
 * Authors       : Gerrit Grunwald, Mark Crossley
 * Last modified : 17.05.2013
 * Revision      : 0.14.3 - Weather Gauge Version
 *
 * Copyright (c) 2011, Gerrit Grunwald, Mark Crossley
 * All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without modification, are permitted
 *  provided that the following conditions are met:
 *
 *  # Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 *  # Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided with the distribution.
 *
 *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *   BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
 *   SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 *   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES, LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 *   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 *   OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
var steelseries=function(){function u(n,t){var i="#"===n.charAt(0)?n.substring(1,7):n,r=parseInt(i.substring(0,2),16),u=parseInt(i.substring(2,4),16),f=parseInt(i.substring(4,6),16);return this.color="rgba("+r+","+u+","+f+","+t+")",this}function bt(t,i,r,u,f){var c=1/255,e=t.getRed(),o=t.getGreen(),s=t.getBlue(),h=t.getAlpha(),p=i.getRed()-e,w=i.getGreen()-o,b=i.getBlue()-s,k=i.getAlpha()*c-h*c,l=p/r*u,a=w/r*u,v=b/r*u,y=k/r*u;return f=f||!1,f?[(e+l).toFixed(0),(o+a).toFixed(0),(s+v).toFixed(0),h+y]:new n((e+l).toFixed(0),(o+a).toFixed(0),(s+v).toFixed(0),h+y)}function di(n,t,i){return{start:n,stop:t,color:i}}function d(n,t){var r=Math.floor(Math.log10(n)),i=n/Math.pow(10,r),u;return u=t?1.5>i?1:3>i?2:7>i?5:10:1>=i?1:2>=i?2:5>=i?5:10,u*Math.pow(10,r)}function kt(n,t,i,r,u,f){var e=t+r,o=i+u;n.beginPath(),n.moveTo(t+f,i),n.lineTo(e-f,i),n.quadraticCurveTo(e,i,e,i+f),n.lineTo(e,i+u-f),n.quadraticCurveTo(e,o,e-f,o),n.lineTo(t+f,o),n.quadraticCurveTo(t,o,t,o-f),n.lineTo(t,i+f),n.quadraticCurveTo(t,i,t+f,i),n.closePath(),n.stroke()}function r(n,t){var i=p.createElement("canvas");return i.width=n,i.height=t,i}function ti(n,t,i){var r=p.createElement("canvas");return r.width=n,r.height=t,i(r.getContext("2d")),r}function rt(n){var t,i=ti(1,1,function(t){t.fillStyle=n,t.beginPath(),t.rect(0,0,1,1),t.fill()});return t=i.getContext("2d").getImageData(0,0,2,2).data,[t[0],t[1],t[2],t[3]]}function fi(t){var u,f,e,o,s,r=rt(t),i=new n(r[0],r[1],r[2],r[3]);return u=ei(i,.32),f=ei(i,.62),e=ii(i,.84),o=ii(i,.94),s=ii(i,1),new v(u,f,i,e,o,s)}function st(n,t,i){var r,u,f,h=Math.floor(n*6),c=n*6-h,e=i*(1-t),o=i*(1-c*t),s=i*(1-(1-c)*t);switch(h%6){case 0:r=i,u=s,f=e;break;case 1:r=o,u=i,f=e;break;case 2:r=e,u=i,f=s;break;case 3:r=e,u=o,f=i;break;case 4:r=s,u=e,f=i;break;case 5:r=i,u=e,f=o}return[Math.floor(r*255),Math.floor(u*255),Math.floor(f*255)]}function ot(n,t,i){var e,r,u,o,s,f;if(n=n/255,t=t/255,i=i/255,r=Math.max(n,t,i),e=Math.min(n,t,i),s=r,f=r-e,o=r===0?0:f/r,r===e)u=0;else{switch(r){case n:u=(t-i)/f+(t<i?6:0);break;case t:u=(i-n)/f+2;break;case i:u=(n-t)/f+4}u/=6}return[u,o,s]}function y(n,t){return n<0?0:n>t?t:n}function ei(t,i){var r=Math.floor(t.getRed()*(1-i)),u=Math.floor(t.getGreen()*(1-i)),f=Math.floor(t.getBlue()*(1-i));return r=y(r,255),u=y(u,255),f=y(f,255),new n(r,u,f,t.getAlpha())}function ii(t,i){var r=Math.round(t.getRed()*(1+i)),u=Math.round(t.getGreen()*(1+i)),f=Math.round(t.getBlue()*(1+i));return r=y(r,255),u=y(u,255),f=y(f,255),new n(r,u,f,t.getAlpha())}function gi(n,t,i){var r,u;if(i<=t)throw"Rotary bounds are of negative or zero size";return r=i-t,u=Math.floor((n-t)/r),n-u*r}function oi(n,t){return gi(t-n,-180,180)}var i=Math.PI*.5,t=Math.PI*2,o=Math.PI,c=Math.PI/180,yt=180/Math.PI,p=document,pt="LCDMono2Ultra,Arial,Verdana,sans-serif",s="Arial,Verdana,sans-serif",si=function(n,u){var vi;u=u||{};var at=undefined===u.gaugeType?steelseries.GaugeType.TYPE4:u.gaugeType,f=undefined===u.size?0:u.size,h=undefined===u.minValue?0:u.minValue,k=undefined===u.maxValue?h+100:u.maxValue,ae=undefined===u.niceScale?!0:u.niceScale,dt=undefined===u.threshold?(k-h)/2+h:u.threshold,ni=undefined===u.thresholdRising?!0:u.thresholdRising,hi=undefined===u.section?null:u.section,ci=undefined===u.area?null:u.area,au=undefined===u.titleString?"":u.titleString,vu=undefined===u.unitString?"":u.unitString,yu=undefined===u.frameDesign?steelseries.FrameDesign.METAL:u.frameDesign,pu=undefined===u.frameVisible?!0:u.frameVisible,li=undefined===u.backgroundColor?steelseries.BackgroundColor.DARK_GRAY:u.backgroundColor,wu=undefined===u.backgroundVisible?!0:u.backgroundVisible,ei=undefined===u.pointerType?steelseries.PointerType.TYPE1:u.pointerType,bu=undefined===u.pointerColor?steelseries.ColorDef.RED:u.pointerColor,ve=undefined===u.knobType?steelseries.KnobType.STANDARD_KNOB:u.knobType,ai=undefined===u.knobStyle?steelseries.KnobStyle.SILVER:u.knobStyle,bi=undefined===u.lcdColor?steelseries.LcdColor.STANDARD:u.lcdColor,tu=undefined===u.lcdVisible?!0:u.lcdVisible,ku=undefined===u.lcdDecimals?2:u.lcdDecimals,ye=undefined===u.digitalFont?!1:u.digitalFont,du=undefined===u.fractionalScaleDecimals?1:u.fractionalScaleDecimals,iu=undefined===u.ledColor?steelseries.LedColor.RED_LED:u.ledColor,ru=undefined===u.ledVisible?!0:u.ledVisible,uu=undefined===u.userLedColor?steelseries.LedColor.GREEN_LED:u.userLedColor,fu=undefined===u.userLedVisible?!1:u.userLedVisible,gu=undefined===u.thresholdVisible?!0:u.thresholdVisible,eu=undefined===u.minMeasuredValueVisible?!1:u.minMeasuredValueVisible,ou=undefined===u.maxMeasuredValueVisible?!1:u.maxMeasuredValueVisible,nf=undefined===u.foregroundType?steelseries.ForegroundType.TYPE1:u.foregroundType,tf=undefined===u.foregroundVisible?!0:u.foregroundVisible,rf=undefined===u.labelNumberFormat?steelseries.LabelNumberFormat.STANDARD:u.labelNumberFormat,ir=undefined===u.playAlarm?!1:u.playAlarm,uf=undefined===u.alarmSound?!1:u.alarmSound,pe=undefined===u.customLayer?null:u.customLayer,we=undefined===u.tickLabelOrientation?at===steelseries.GaugeType.TYPE1?steelseries.TickLabelOrientation.TANGENT:steelseries.TickLabelOrientation.NORMAL:u.tickLabelOrientation,su=undefined===u.trendVisible?!1:u.trendVisible,cr=undefined===u.trendColors?[steelseries.LedColor.RED_LED,steelseries.LedColor.GREEN_LED,steelseries.LedColor.CYAN_LED]:u.trendColors,lr=undefined===u.useOdometer?!1:u.useOdometer,oi=undefined===u.odometerParams?{}:u.odometerParams,be=undefined===u.odometerUseValue?!1:u.odometerUseValue,ff=undefined===u.fullScaleDeflectionTime?2.5:u.fullScaleDeflectionTime,e=p.getElementById(n).getContext("2d");f===0&&(f=Math.min(e.canvas.width,e.canvas.height)),e.canvas.width=f,e.canvas.height=f,ir&&uf!==!1&&(vi=p.createElement("audio"),vi.setAttribute("src",uf),vi.setAttribute("preload","auto"));var y=h,ar=h,ef=this,yi=k,pi=h,ut=!1,vr=!1,of=0,hu=0,ki,wi=!1,sf=steelseries.TrendState.OFF,yr=f*.06,pr=f*.29,wr=f*.36,di,vt,br,yt,bt,cu=vt+(y-h)*bt,v=f,rt=f,st=v/2,ct=rt/2,ti=f*.093457,ke=.6*v,de=.4*rt,ge=at===steelseries.GaugeType.TYPE3?.6*v:st-ti/2,no=at===steelseries.GaugeType.TYPE3?.72*rt:.75*rt,lu=Math.floor(v/10),to=lu+"px "+s,io=lu+"px "+pt,hf=rt*.13,rr=v*.4,cf=(v-rr)/2,lf=rt*.57,af,ro=rt*.61,vf=v*.006,yf=!1,kr=h,dr=k,ur=k-h,ii=dr-kr,gr=0,ri=0,gi=10,pf=10,uo=function(){ae?(ur=d(k-h,!1),ri=d(ur/(pf-1),!0),kr=Math.floor(h/ri)*ri,dr=Math.ceil(k/ri)*ri,gr=d(ri/(gi-1),!0),h=kr,k=dr,ii=k-h):(ur=k-h,kr=h,dr=k,ii=ur,ri=d(ur/(pf-1),!0),gr=d(ri/(gi-1),!0));switch(at.type){case"type1":di=0,vt=o,br=i,yt=i,bt=yt/ii;break;case"type2":di=0,vt=o,br=i,yt=o,bt=yt/ii;break;case"type3":di=0,vt=i,br=0,yt=1.5*o,bt=yt/ii;break;case"type4":default:di=60*c,vt=i+di/2,br=0,yt=t-di,bt=yt/ii}cu=vt+(y-h)*bt},fr=r(f,f),wf=fr.getContext("2d"),er=r(f,f),lt=er.getContext("2d"),bf,nr=r(ti,ti),kf=nr.getContext("2d"),si=r(ti,ti),df=si.getContext("2d"),tr=si,fi=r(ti,ti),gf=fi.getContext("2d"),gt=r(ti,ti),ne=gt.getContext("2d"),kt=gt,te=r(Math.ceil(f*.028037),Math.ceil(f*.028037)),fo=te.getContext("2d"),ie=r(Math.ceil(f*.028037),Math.ceil(f*.028037)),eo=ie.getContext("2d"),or=r(f,f),re=or.getContext("2d"),sr=r(f,f),ue=sr.getContext("2d"),fe,ee,oe,se,he,nu,ce;lr&&tu&&(nu=r(10,10),ce=nu.getContext("2d"));var oo=function(n,t){n.restore(),n.save(),n.textAlign="right",n.strokeStyle=bi.textColor,n.fillStyle=bi.textColor,(bi===steelseries.LcdColor.STANDARD||bi===steelseries.LcdColor.STANDARD_GREEN)&&(n.shadowColor="gray",n.shadowOffsetX=v*.007,n.shadowOffsetY=v*.007,n.shadowBlur=v*.007),n.font=ye?io:to,n.fillText(t.toFixed(ku),cf+rr-rr*.05,lf+hf*.5+lu*.38,rr*.9),n.restore()},so=function(n){n.save(),"type1"===at.type&&n.drawImage(l(Math.ceil(rt*.037383),steelseries.KnobType.STANDARD_KNOB,ai),v*.523364,rt*.130841),("type1"===at.type||"type2"===at.type)&&n.drawImage(l(Math.ceil(rt*.037383),steelseries.KnobType.STANDARD_KNOB,ai),v*.130841,rt*.514018),("type2"===at.type||"type3"===at.type)&&n.drawImage(l(Math.ceil(rt*.037383),steelseries.KnobType.STANDARD_KNOB,ai),v*.831775,rt*.514018),"type3"===at.type&&n.drawImage(l(Math.ceil(rt*.037383),steelseries.KnobType.STANDARD_KNOB,ai),v*.523364,rt*.831775),"type4"===at.type&&(n.drawImage(l(Math.ceil(rt*.037383),steelseries.KnobType.STANDARD_KNOB,ai),v*.336448,rt*.803738),n.drawImage(l(Math.ceil(rt*.037383),steelseries.KnobType.STANDARD_KNOB,ai),v*.626168,rt*.803738)),n.restore()},ho=function(){var t=p.createElement("canvas"),n,i;return t.width=Math.ceil(f*.046728),t.height=Math.ceil(t.width*.9),n=t.getContext("2d"),n.save(),i=n.createLinearGradient(0,.1,0,t.height*.9),i.addColorStop(0,"#520000"),i.addColorStop(.3,"#fc1d00"),i.addColorStop(.59,"#fc1d00"),i.addColorStop(1,"#520000"),n.fillStyle=i,n.beginPath(),n.moveTo(t.width*.5,.1),n.lineTo(t.width*.9,t.height*.9),n.lineTo(t.width*.1,t.height*.9),n.lineTo(t.width*.5,.1),n.closePath(),n.fill(),n.strokeStyle="#FFFFFF",n.stroke(),n.restore(),t},le=function(n,t,i,r,u){if(t<h?t=h:t>k&&(t=k),i<h?i=h:i>k&&(i=k),!(t>=i)){n.save(),n.strokeStyle=r,n.fillStyle=r,n.lineWidth=v*.035;var f=yt/ii*t-yt/ii*h,e=f+(i-t)/(ii/yt);n.translate(st,ct),n.rotate(vt),n.beginPath(),u?(n.moveTo(0,0),n.arc(0,0,v*.365-n.lineWidth/2,f,e,!1)):n.arc(0,0,v*.365,f,e,!1),u?(n.moveTo(0,0),n.fill()):n.stroke(),n.translate(-st,-ct),n.restore()}},co=function(n,t){var w=Math.ceil(v*.04),f=vt,r=bt*gr,u,e=h,c=gi-1,a=v*.38,b=v*.35,d=v*.355,g=v*.36,p=v*.3,l=v*.1,nt=gi/2,tt=parseFloat(k.toFixed(2)),y;for(li.labelColor.setAlpha(1),n.save(),n.textAlign="center",n.textBaseline="middle",n.font=w+"px"+s,n.strokeStyle=li.labelColor.getRgbaColor(),n.fillStyle=li.labelColor.getRgbaColor(),n.translate(st,ct),n.rotate(vt),(at.type==="type1"||at.type==="type2")&&(l=v*.04),y=h;parseFloat(y.toFixed(2))<=tt;y+=gr){if(u=r+i,c++,c===gi){n.lineWidth=1.5,n.beginPath(),n.moveTo(a,0),n.lineTo(b,0),n.closePath(),n.stroke(),n.save(),n.translate(p,0);switch(we.type){case"horizontal":u=-f;break;case"tangent":u=f<=i+o?o:0;break;case"normal":default:u=i}n.rotate(u);switch(t.format){case"fractional":n.fillText(e.toFixed(du),0,0,l);break;case"scientific":n.fillText(e.toPrecision(2),0,0,l);break;case"standard":default:n.fillText(e.toFixed(0),0,0,l)}n.translate(-p,0),n.restore(),e+=ri,c=0,n.rotate(r),f+=r;continue}0==gi%2&&c===nt?(n.lineWidth=1,n.beginPath(),n.moveTo(a,0),n.lineTo(d,0),n.closePath(),n.stroke()):(n.lineWidth=.5,n.beginPath(),n.moveTo(a,0),n.lineTo(g,0),n.closePath(),n.stroke()),n.rotate(r),f+=r}n.translate(-st,-ct),n.restore()},ot=function(n){var t,r,e;n=n||{};var o=undefined===n.frame?!1:n.frame,u=undefined===n.background?!1:n.background,s=undefined===n.led?!1:n.led,c=undefined===n.userLed?!1:n.userLed,l=undefined===n.pointer?!1:n.pointer,p=undefined===n.foreground?!1:n.foreground,b=undefined===n.trend?!1:n.trend,k=undefined===n.odo?!1:n.odo;if(yf=!0,uo(),o&&pu&&g(wf,yu,st,ct,v,rt),u&&wu&&(nt(lt,li,st,ct,v,rt),wt(lt,pe,st,ct,v,rt)),s&&(kf.drawImage(a(Math.ceil(f*.093457),1,iu),0,0),df.drawImage(a(Math.ceil(f*.093457),0,iu),0,0)),c&&(gf.drawImage(a(Math.ceil(f*.093457),1,uu),0,0),ne.drawImage(a(Math.ceil(f*.093457),0,uu),0,0)),eu&&fo.drawImage(et(Math.ceil(f*.028037),steelseries.ColorDef.BLUE.dark.getRgbaColor(),!0,!0),0,0),ou&&eo.drawImage(et(Math.ceil(f*.028037),steelseries.ColorDef.RED.medium.getRgbaColor(),!0),0,0),u&&wu){if(so(lt),null!==hi&&0<hi.length){t=hi.length;do t--,le(lt,hi[t].start,hi[t].stop,hi[t].color,!1);while(0<t)}if(null!==ci&&0<ci.length){r=ci.length;do r--,le(lt,ci[r].start,ci[r].stop,ci[r].color,!0);while(0<r)}co(lt,rf),ui(lt,v,rt,au,vu,li,!0,!0)}u&&gu&&(lt.save(),lt.translate(st,ct),lt.rotate(vt+(dt-h)*bt+i),lt.translate(-st,-ct),lt.drawImage(ho(),v*.475,rt*.13),lt.translate(st,ct),lt.restore()),u&&tu&&(lr&&k?(he=new steelseries.Odometer("",{_context:ce,height:f*.075,decimals:oi.decimals,digits:oi.digits===undefined?5:oi.digits,valueForeColor:oi.valueForeColor,valueBackColor:oi.valueBackColor,decimalForeColor:oi.decimalForeColor,decimalBackColor:oi.decimalBackColor,font:oi.font,value:y}),af=(v-nu.width)/2):lr||(bf=it(rr,hf,bi),lt.drawImage(bf,cf,lf))),l&&ft(re,v,ei,bu,li.labelColor),p&&tf&&(e=ei.type==="type15"||ei.type==="type16"?!1:!0,tt(ue,nf,v,rt,e,ve,ai,at)),b&&su&&(fe=w(yr,steelseries.TrendState.UP,cr),ee=w(yr,steelseries.TrendState.STEADY,cr),oe=w(yr,steelseries.TrendState.DOWN,cr),se=w(yr,steelseries.TrendState.OFF,cr))},ht=function(n){n=n||{};var t=undefined===n.frame?!1:n.frame,i=undefined===n.background?!1:n.background,r=undefined===n.led?!1:n.led,u=undefined===n.userLed?!1:n.userLed,e=undefined===n.pointer?!1:n.pointer,o=undefined===n.foreground?!1:n.foreground;t&&(fr.width=f,fr.height=f,wf=fr.getContext("2d")),i&&(er.width=f,er.height=f,lt=er.getContext("2d")),r&&(nr.width=Math.ceil(f*.093457),nr.height=Math.ceil(f*.093457),kf=nr.getContext("2d"),si.width=Math.ceil(f*.093457),si.height=Math.ceil(f*.093457),df=si.getContext("2d"),tr=si),u&&(fi.width=Math.ceil(f*.093457),fi.height=Math.ceil(f*.093457),gf=fi.getContext("2d"),gt.width=Math.ceil(f*.093457),gt.height=Math.ceil(f*.093457),ne=gt.getContext("2d"),kt=gt),e&&(or.width=f,or.height=f,re=or.getContext("2d")),o&&(sr.width=f,sr.height=f,ue=sr.getContext("2d"))},lo=function(){ru&&(tr=tr===nr?si:nr,wi||(wi=!0,b(ef.repaint)))},ao=function(){fu&&(kt=kt===fi?gt:fi,wi||(wi=!0,b(ef.repaint)))},hr=function(n){n?of=setInterval(lo,1e3):(clearInterval(of),tr=si)},vo=function(n){n?hu=setInterval(ao,1e3):(clearInterval(hu),kt=gt)};return this.setValue=function(n){n=parseFloat(n);var t=n<h?h:n>k?k:n;return y!==t&&(y=t,y>pi&&(pi=y),y<yi&&(yi=y),y>=dt&&!ut&&ni||y<=dt&&!ut&&!ni?(ut=!0,hr(ut),ir&&vi.play()):(y<dt&&ut&&ni||y>dt&&ut&&!ni)&&(ut=!1,hr(ut),ir&&vi.pause()),this.repaint()),this},this.getValue=function(){return y},this.setOdoValue=function(n){n=parseFloat(n);var t=n<0?0:n;return ar!==t&&(ar=t,this.repaint()),this},this.getOdoValue=function(){return ar},this.setValueAnimated=function(n){n=parseFloat(n);var i=n<h?h:n>k?k:n,r=this,t;return y!==i&&(undefined!==ki&&ki.isPlaying&&ki.stop(),t=ff*Math.abs(i-y)/(k-h),t=Math.max(t,ff/5),ki=new Tween({},"",Tween.regularEaseInOut,y,i,t),ki.onMotionChanged=function(n){y=n.target._pos,y>=dt&&!ut&&ni||y<=dt&&!ut&&!ni?(ut=!0,hr(ut),ir&&vi.play()):(y<dt&&ut&&ni||y>dt&&ut&&!ni)&&(ut=!1,hr(ut),ir&&vi.pause()),y>pi&&(pi=y),y<yi&&(yi=y),wi||(wi=!0,b(r.repaint))},ki.start()),this},this.resetMinMeasuredValue=function(){yi=y,this.repaint()},this.resetMaxMeasuredValue=function(){return pi=y,this.repaint(),this},this.setMinMeasuredValueVisible=function(n){return eu=!!n,this.repaint(),this},this.setMaxMeasuredValueVisible=function(n){return ou=!!n,this.repaint(),this},this.setMaxMeasuredValue=function(n){n=parseFloat(n);var t=n<h?h:n>k?k:n;return pi=t,this.repaint(),this},this.setMinMeasuredValue=function(n){n=parseFloat(n);var t=n<h?h:n>k?k:n;return yi=t,this.repaint(),this},this.setTitleString=function(n){return au=n,ht({background:!0}),ot({background:!0}),this.repaint(),this},this.setUnitString=function(n){return vu=n,ht({background:!0}),ot({background:!0}),this.repaint(),this},this.setMinValue=function(n){return h=parseFloat(n),ht({frame:!0,background:!0}),ot({frame:!0,background:!0}),this.repaint(),this},this.getMinValue=function(){return h},this.setMaxValue=function(n){return k=parseFloat(n),ht({frame:!0,background:!0}),ot({frame:!0,background:!0}),this.repaint(),this},this.getMaxValue=function(){return k},this.setThreshold=function(n){n=parseFloat(n);var t=n<h?h:n>k?k:n;return dt=t,ht({background:!0}),ot({background:!0}),this.repaint(),this},this.setArea=function(n){return ci=n,ht({background:!0,foreground:!0}),ot({background:!0,foreground:!0}),this.repaint(),this},this.setSection=function(n){return hi=n,ht({background:!0,foreground:!0}),ot({background:!0,foreground:!0}),this.repaint(),this},this.setThresholdVisible=function(n){return gu=!!n,this.repaint(),this},this.setThresholdRising=function(n){return ni=!!n,ut=!ut,hr(ut),this.repaint(),this},this.setLcdDecimals=function(n){return ku=parseInt(n,10),this.repaint(),this},this.setFrameDesign=function(n){return ht({frame:!0}),yu=n,ot({frame:!0}),this.repaint(),this},this.setBackgroundColor=function(n){return ht({background:!0,pointer:ei.type==="type2"||ei.type==="type13"?!0:!1}),li=n,ot({background:!0,pointer:ei.type==="type2"||ei.type==="type13"?!0:!1}),this.repaint(),this},this.setForegroundType=function(n){return ht({foreground:!0}),nf=n,ot({foreground:!0}),this.repaint(),this},this.setPointerType=function(n){return ht({pointer:!0,foreground:!0}),ei=n,ot({pointer:!0,foreground:!0}),this.repaint(),this},this.setPointerColor=function(n){return ht({pointer:!0}),bu=n,ot({pointer:!0}),this.repaint(),this},this.setLedColor=function(n){return ht({led:!0}),iu=n,ot({led:!0}),this.repaint(),this},this.setUserLedColor=function(n){return ht({userLed:!0}),uu=n,ot({userLed:!0}),this.repaint(),this},this.toggleUserLed=function(){return kt=kt===fi?gt:fi,this.repaint(),this},this.setUserLedOnOff=function(n){return kt=!0===n?fi:gt,this.repaint(),this},this.blinkUserLed=function(n){return n?vr||(vo(!0),vr=!0):vr&&(clearInterval(hu),vr=!1),this},this.setLedVisible=function(n){return ru=!!n,this.repaint(),this},this.setUserLedVisible=function(n){return fu=!!n,this.repaint(),this},this.setLcdColor=function(n){return bi=n,ht({background:!0}),ot({background:!0}),this.repaint(),this},this.setTrend=function(n){return sf=n,this.repaint(),this},this.setTrendVisible=function(n){return su=!!n,this.repaint(),this},this.setFractionalScaleDecimals=function(n){return du=parseInt(n,10),ht({background:!0}),ot({background:!0}),this.repaint(),this},this.setLabelNumberFormat=function(n){return rf=n,ht({background:!0}),ot({background:!0}),this.repaint(),this},this.repaint=function(){if(yf||ot({frame:!0,background:!0,led:!0,userLed:!0,pointer:!0,trend:!0,foreground:!0,odo:!0}),e.clearRect(0,0,f,f),pu&&e.drawImage(fr,0,0),e.drawImage(er,0,0),tu&&(lr?(he.setValue(be?y:ar),e.drawImage(nu,af,ro)):oo(e,y)),ru&&e.drawImage(tr,ke,de),fu&&e.drawImage(kt,ge,no),su)switch(sf.state){case"up":e.drawImage(fe,pr,wr);break;case"steady":e.drawImage(ee,pr,wr);break;case"down":e.drawImage(oe,pr,wr);break;case"off":e.drawImage(se,pr,wr)}eu&&(e.save(),e.translate(st,ct),e.rotate(vt+i+(yi-h)*bt),e.translate(-st,-ct),e.drawImage(te,e.canvas.width*.4865,e.canvas.height*.105),e.restore()),ou&&(e.save(),e.translate(st,ct),e.rotate(vt+i+(pi-h)*bt),e.translate(-st,-ct),e.drawImage(ie,e.canvas.width*.4865,e.canvas.height*.105),e.restore()),cu=vt+i+(y-h)*bt,e.save(),e.translate(st,ct),e.rotate(cu),e.translate(-st,-ct),e.shadowColor="rgba(0, 0, 0, 0.8)",e.shadowOffsetX=e.shadowOffsetY=vf,e.shadowBlur=vf*2,e.drawImage(or,0,0),e.restore(),tf&&e.drawImage(sr,0,0),wi=!1},this.repaint(),this},hi=function(n,u){var ci;u=u||{};var si=undefined===u.gaugeType?steelseries.GaugeType.TYPE4:u.gaugeType,h=undefined===u.size?0:u.size,f=undefined===u.minValue?0:u.minValue,l=undefined===u.maxValue?f+100:u.maxValue,ie=undefined===u.niceScale?!0:u.niceScale,dt=undefined===u.threshold?(l-f)/2+f:u.threshold,gt=undefined===u.thresholdRising?!0:u.thresholdRising,hi=undefined===u.section?null:u.section,ou=undefined===u.useSectionColors?!1:u.useSectionColors,su=undefined===u.titleString?"":u.titleString,hu=undefined===u.unitString?"":u.unitString,cu=undefined===u.frameDesign?steelseries.FrameDesign.METAL:u.frameDesign,lu=undefined===u.frameVisible?!0:u.frameVisible,ai=undefined===u.backgroundColor?steelseries.BackgroundColor.DARK_GRAY:u.backgroundColor,au=undefined===u.backgroundVisible?!0:u.backgroundVisible,or=undefined===u.valueColor?steelseries.ColorDef.RED:u.valueColor,vi=undefined===u.lcdColor?steelseries.LcdColor.STANDARD:u.lcdColor,vu=undefined===u.lcdVisible?!0:u.lcdVisible,yu=undefined===u.lcdDecimals?2:u.lcdDecimals,re=undefined===u.digitalFont?!1:u.digitalFont,pu=undefined===u.fractionalScaleDecimals?1:u.fractionalScaleDecimals,ue=undefined===u.customLayer?null:u.customLayer,kr=undefined===u.ledColor?steelseries.LedColor.RED_LED:u.ledColor,dr=undefined===u.ledVisible?!0:u.ledVisible,gr=undefined===u.userLedColor?steelseries.LedColor.GREEN_LED:u.userLedColor,nu=undefined===u.userLedVisible?!1:u.userLedVisible,wu=undefined===u.labelNumberFormat?steelseries.LabelNumberFormat.STANDARD:u.labelNumberFormat,bu=undefined===u.foregroundType?steelseries.ForegroundType.TYPE1:u.foregroundType,ku=undefined===u.foregroundVisible?!0:u.foregroundVisible,di=undefined===u.playAlarm?!1:u.playAlarm,du=undefined===u.alarmSound?!1:u.alarmSound,gi=undefined===u.valueGradient?null:u.valueGradient,gu=undefined===u.useValueGradient?!1:u.useValueGradient,fe=undefined===u.tickLabelOrientation?si===steelseries.GaugeType.TYPE1?steelseries.TickLabelOrientation.TANGENT:steelseries.TickLabelOrientation.NORMAL:u.tickLabelOrientation,tu=undefined===u.trendVisible?!1:u.trendVisible,sr=undefined===u.trendColors?[steelseries.LedColor.RED_LED,steelseries.LedColor.GREEN_LED,steelseries.LedColor.CYAN_LED]:u.trendColors,nf=undefined===u.fullScaleDeflectionTime?2.5:u.fullScaleDeflectionTime,y=p.getElementById(n).getContext("2d");h===0&&(h=Math.min(y.canvas.width,y.canvas.height)),y.canvas.width=h,y.canvas.height=h,di&&du!==!1&&(ci=p.createElement("audio"),ci.setAttribute("src",du),ci.setAttribute("preload","auto"));var ft=f,at=l-f,rt=!1,tf=0,hr=!1,iu=0,yi,rf=this,li=!1,lt,ot,pi,ri,k,ni,bt,ee,wi=[],cr=!1,ru=!1,e=h,st=h,et=e/2,ht=st/2,uu=Math.floor(e/10),oe=uu+"px "+s,se=uu+"px "+pt,fu=st*.13,nr=e*.4,uf=(e-nr)/2,ff=st/2-fu/2,he=e*.116822,ce=e*.485981,v=Math.ceil(h*.093457),ef=e*.53,of=st*.61,le=si===steelseries.GaugeType.TYPE3?.7*e:et-v/2,ae=si===steelseries.GaugeType.TYPE3?.61*st:.75*st,sf=steelseries.TrendState.OFF,lr=h*.06,ar=h*.38,vr=h*.57;switch(si.type){case"type1":lt=0,ot=o,pi=0,ri=i,k=i,ni=k*yt,bt=k/at;break;case"type2":lt=0,ot=o,pi=0,ri=i,k=o,ni=k*yt,bt=k/at;break;case"type3":lt=0,ot=i,pi=-i,ri=0,k=1.5*o,ni=k*yt,bt=k/at;break;case"type4":default:lt=60*c,ot=i+lt/2,pi=-t/6,ri=0,k=t-lt,ni=k*yt,bt=k/at}var tr=r(h,h),hf=tr.getContext("2d"),ir=r(h,h),ei=ir.getContext("2d"),cf,rr=r(Math.ceil(h*.060747),Math.ceil(h*.023364)),eu=rr.getContext("2d"),bi=r(v,v),lf=bi.getContext("2d"),oi=r(v,v),af=oi.getContext("2d"),ki=oi,ti=r(v,v),vf=ti.getContext("2d"),kt=r(v,v),yf=kt.getContext("2d"),vt=kt,ve,ur=r(h,h),pf=ur.getContext("2d"),wf,bf,kf,df,gf=!1,yr=f,pr=l,fr=l-f;at=pr-yr;var wr=0,ii=0,br=10,ne=10,ye=function(){ie?(fr=d(l-f,!1),ii=d(fr/(ne-1),!0),yr=Math.floor(f/ii)*ii,pr=Math.ceil(l/ii)*ii,wr=d(ii/(br-1),!0),f=yr,l=pr,at=l-f):(fr=l-f,yr=f,pr=l,at=fr,ii=d(fr/(ne-1),!0),wr=d(ii/(br-1),!0));switch(si.type){case"type1":lt=0,ot=o,ri=i,k=i,bt=k/at;break;case"type2":lt=0,ot=o,ri=i,k=o,bt=k/at;break;case"type3":lt=0,ot=i,ri=0,k=1.5*o,bt=k/at;break;case"type4":default:lt=60*c,ot=i+lt/2,ri=0,k=t-lt,bt=k/at}ee=ot+(ft-f)*bt},ut=function(n){var t;n=n||{};var r=undefined===n.frame?!1:n.frame,i=undefined===n.background?!1:n.background,u=undefined===n.led?!1:n.led,o=undefined===n.userLed?!1:n.userLed,s=undefined===n.value?!1:n.value,h=undefined===n.foreground?!1:n.foreground,c=undefined===n.trend?!1:n.trend;if(gf=!0,ye(),r&&lu&&g(hf,cu,et,ht,e,st),i&&au&&(nt(ei,ai,et,ht,e,st),wt(ei,ue,et,ht,e,st)),u&&(lf.drawImage(a(v,1,kr),0,0),af.drawImage(a(v,0,kr),0,0),ve=ei.getImageData(ef,of,v,v)),o&&(vf.drawImage(a(Math.ceil(v),1,gr),0,0),yf.drawImage(a(Math.ceil(v),0,gr),0,0)),i&&pe(ei),i&&au&&(be(ei,wu),ui(ei,e,st,su,hu,ai,!0,!0)),i&&vu&&(cf=it(nr,fu,vi),ei.drawImage(cf,uf,ff)),cr=!1,ou&&null!==hi&&0<hi.length){cr=!0,t=hi.length,wi=[];do t--,wi.push({start:(hi[t].start+Math.abs(f))/(l-f)*ni,stop:(hi[t].stop+Math.abs(f))/(l-f)*ni,color:fi(hi[t].color)});while(0<t)}ru=!1,gu&&gi!==null&&(cr=!1,ru=!0),s&&te(eu,or),h&&ku&&tt(pf,bu,e,st,!1),c&&tu&&(wf=w(lr,steelseries.TrendState.UP,sr),bf=w(lr,steelseries.TrendState.STEADY,sr),kf=w(lr,steelseries.TrendState.DOWN,sr),df=w(lr,steelseries.TrendState.OFF,sr))},ct=function(n){n=n||{};var t=undefined===n.frame?!1:n.frame,i=undefined===n.background?!1:n.background,r=undefined===n.led?!1:n.led,u=undefined===n.userLed?!1:n.userLed,f=undefined===n.value?!1:n.value,e=undefined===n.foreground?!1:n.foreground;t&&(tr.width=h,tr.height=h,hf=tr.getContext("2d")),i&&(ir.width=h,ir.height=h,ei=ir.getContext("2d")),f&&(rr.width=Math.ceil(h*.060747),rr.height=Math.ceil(h*.023364),eu=rr.getContext("2d")),r&&(bi.width=Math.ceil(v),bi.height=Math.ceil(v),lf=bi.getContext("2d"),oi.width=Math.ceil(v),oi.height=Math.ceil(v),af=oi.getContext("2d"),ki=oi),u&&(ti.width=Math.ceil(v),ti.height=Math.ceil(v),vf=ti.getContext("2d"),kt.width=Math.ceil(v),kt.height=Math.ceil(v),yf=kt.getContext("2d"),vt=kt),e&&(ur.width=h,ur.height=h,pf=ur.getContext("2d"))},pe=function(n){var t,r,i;n.save(),n.save(),n.lineWidth=h*.085,n.beginPath(),n.translate(et,ht),n.rotate(ot-4*c),n.translate(-et,-ht),n.arc(et,ht,e*.35514,0,k+8*c,!1),n.rotate(-ot),t=n.createLinearGradient(0,.107476*st,0,.897195*st),t.addColorStop(0,"#000000"),t.addColorStop(.22,"#333333"),t.addColorStop(.76,"#333333"),t.addColorStop(1,"#cccccc"),n.strokeStyle=t,n.stroke(),n.restore(),n.save(),n.lineWidth=h*.075,n.beginPath(),n.translate(et,ht),n.rotate(ot-4*c),n.translate(-et,-ht),n.arc(et,ht,e*.35514,0,k+8*c,!1),n.rotate(-ot),r=n.createLinearGradient(0,.112149*st,0,.892523*st),r.addColorStop(0,"#111111"),r.addColorStop(1,"#333333"),n.strokeStyle=r,n.stroke(),n.restore();var f=(e*.116822+e*.060747)/2,o=(e*.485981+e*.023364)/2,u=n.createRadialGradient(f,o,0,f,o,.030373*e);for(u.addColorStop(0,"#3c3c3c"),u.addColorStop(1,"#323232"),i=0,i=0;i<=ni;i+=5)n.save(),n.translate(et,ht),n.rotate(i*c+pi),n.translate(-et,-ht),n.beginPath(),n.rect(e*.116822,e*.485981,e*.060747,e*.023364),n.closePath(),n.fillStyle=u,n.fill(),n.restore();n.restore()},te=function(n,t){n.save(),n.beginPath(),n.rect(0,0,n.canvas.width,n.canvas.height),n.closePath();var r=n.canvas.width/2,u=n.canvas.height/2,i=y.createRadialGradient(r,u,0,r,u,n.canvas.width/2);i.addColorStop(0,t.light.getRgbaColor()),i.addColorStop(1,t.dark.getRgbaColor()),n.fillStyle=i,n.fill(),n.restore()},we=function(n,t){n.save(),n.textAlign="right",n.strokeStyle=vi.textColor,n.fillStyle=vi.textColor,(vi===steelseries.LcdColor.STANDARD||vi===steelseries.LcdColor.STANDARD_GREEN)&&(n.shadowColor="gray",n.shadowOffsetX=e*.007,n.shadowOffsetY=e*.007,n.shadowBlur=e*.007),n.font=re?se:oe,n.fillText(t.toFixed(yu),uf+nr-nr*.05,ff+fu*.5+uu*.38,nr*.9),n.restore()},be=function(n,t){var h=ot,r=bt*wr,u,w=Math.ceil(e*.04),c=f,v=br-1,p=e*.28,a=e*.1,b=parseFloat(l.toFixed(2)),y;for(ai.labelColor.setAlpha(1),n.save(),n.textAlign="center",n.textBaseline="middle",n.font=w+"px "+s,n.strokeStyle=ai.labelColor.getRgbaColor(),n.fillStyle=ai.labelColor.getRgbaColor(),n.translate(et,ht),n.rotate(ot),(si.type==="type1"||si.type==="type2")&&(a=e*.0375),y=f;parseFloat(y.toFixed(2))<=b;y+=wr){if(u=+r+i,v++,v===br){n.save(),n.translate(p,0);switch(fe.type){case"horizontal":u=-h;break;case"tangent":u=h<=i+o?o:0;break;case"normal":default:u=i}n.rotate(u);switch(t.format){case"fractional":n.fillText(c.toFixed(pu),0,0,a);break;case"scientific":n.fillText(c.toPrecision(2),0,0,a);break;case"standard":default:n.fillText(c.toFixed(0),0,0,a)}n.translate(-p,0),n.restore(),c+=ii,v=0,n.rotate(r),h+=r;continue}n.rotate(r),h+=r}n.translate(-et,-ht),n.restore()},er=function(n){n?tf=setInterval(de,1e3):(clearInterval(tf),ki=oi)},ke=function(n){n?iu=setInterval(ge,1e3):(clearInterval(iu),vt=kt)},de=function(){dr&&(ki=ki===bi?oi:bi,li||(li=!0,b(rf.repaint)))},ge=function(){nu&&(vt=vt===ti?kt:ti,li||(li=!0,b(rf.repaint)))};return this.setValue=function(n){n=parseFloat(n);var t=n<f?f:n>l?l:n;return ft!==t&&(ft=t,ft>=dt&&!rt&&gt||ft<=dt&&!rt&&!gt?(rt=!0,er(rt),di&&ci.play()):(ft<dt&&rt&&gt||ft>dt&&rt&&!gt)&&(rt=!1,er(rt),di&&ci.pause()),this.repaint()),this},this.getValue=function(){return ft},this.setValueAnimated=function(n){n=parseFloat(n);var i=n<f?f:n>l?l:n,r=this,t;return ft!==i&&(undefined!==yi&&yi.isPlaying&&yi.stop(),t=nf*Math.abs(i-ft)/(l-f),t=Math.max(t,nf/5),yi=new Tween({},"",Tween.regularEaseInOut,ft,i,t),yi.onMotionChanged=function(n){ft=n.target._pos,ft>=dt&&!rt&&gt||ft<=dt&&!rt&&!gt?(rt=!0,er(rt),di&&ci.play()):(ft<dt&&rt&&gt||ft>dt&&rt&&!gt)&&(rt=!1,er(rt),di&&ci.pause()),li||(li=!0,b(r.repaint))},yi.start()),this},this.setFrameDesign=function(n){return ct({frame:!0}),cu=n,ut({frame:!0}),this.repaint(),this},this.setBackgroundColor=function(n){return ct({background:!0,led:!0}),ai=n,ut({background:!0,led:!0}),this.repaint(),this},this.setForegroundType=function(n){return ct({foreground:!0}),bu=n,ut({foreground:!0}),this.repaint(),this},this.setValueColor=function(n){return ct({value:!0}),or=n,ut({value:!0}),this.repaint(),this},this.setLedColor=function(n){return ct({led:!0}),kr=n,ut({led:!0}),this.repaint(),this},this.setUserLedColor=function(n){return ct({userLed:!0}),gr=n,ut({userLed:!0}),this.repaint(),this},this.toggleUserLed=function(){return vt=vt===ti?kt:ti,this.repaint(),this},this.setUserLedOnOff=function(n){return vt=!0===n?ti:kt,this.repaint(),this},this.blinkUserLed=function(n){return n?hr||(ke(!0),hr=!0):hr&&(clearInterval(iu),hr=!1),this},this.setLedVisible=function(n){return dr=!!n,this.repaint(),this},this.setUserLedVisible=function(n){return nu=!!n,this.repaint(),this},this.setLcdColor=function(n){return vi=n,ct({background:!0}),ut({background:!0}),this.repaint(),this},this.setLcdDecimals=function(n){return yu=parseInt(n,10),this.repaint(),this},this.setSection=function(n){return hi=n,ut(),this.repaint(),this},this.setSectionActive=function(n){return ou=n,ut(),this.repaint(),this},this.setGradient=function(n){return gi=n,ut(),this.repaint(),this},this.setGradientActive=function(n){return gu=n,ut(),this.repaint(),this},this.setMinValue=function(n){return f=n,ct({background:!0}),ut({background:!0}),this.repaint(),this},this.getMinValue=function(){return f},this.setMaxValue=function(n){return l=n,ct({background:!0}),ut({background:!0}),this.repaint(),this},this.getMaxValue=function(){return l},this.setThreshold=function(n){n=parseFloat(n);var t=n<f?f:n>l?l:n;return dt=t,ct({background:!0}),ut({background:!0}),this.repaint(),this},this.setThresholdRising=function(n){return gt=!!n,rt=!rt,er(rt),this.repaint(),this},this.setTitleString=function(n){return su=n,ct({background:!0}),ut({background:!0}),this.repaint(),this},this.setUnitString=function(n){return hu=n,ct({background:!0}),ut({background:!0}),this.repaint(),this},this.setTrend=function(n){return sf=n,this.repaint(),this},this.setTrendVisible=function(n){return tu=!!n,this.repaint(),this},this.setFractionalScaleDecimals=function(n){pu=parseInt(n,10),ct({background:!0}),ut({background:!0}),this.repaint()},this.setLabelNumberFormat=function(n){return wu=n,ct({background:!0}),ut({background:!0}),this.repaint(),this},this.repaint=function(){var s=(ft-f)/(l-f)*ni,t,u=or,n,i,e,o,r;for(gf||ut({frame:!0,background:!0,led:!0,userLed:!0,value:!0,trend:!0,foreground:!0}),y.clearRect(0,0,h,h),lu&&y.drawImage(tr,0,0),y.drawImage(ir,0,0),n=0;n<=s;n+=5){if(t=or,ru)e=f+n/ni*(l-f),o=gi.getEnd()-gi.getStart(),r=e/o,r=Math.max(Math.min(r,1),0),t=fi(gi.getColorAt(r).getRgbaColor());else if(cr)for(i=0;i<wi.length;i++)if(n>=wi[i].start&&n<wi[i].stop){t=wi[i].color;break}u.medium.getHexColor()!==t.medium.getHexColor()&&(te(eu,t),u=t),y.save(),y.translate(et,ht),y.rotate(n*c+pi),y.translate(-et,-ht),y.drawImage(rr,he,ce),y.restore()}if(vu&&we(y,ft),dr&&y.drawImage(ki,ef,of),nu&&y.drawImage(vt,le,ae),tu)switch(sf.state){case"up":y.drawImage(wf,ar,vr);break;case"steady":y.drawImage(bf,ar,vr);break;case"down":y.drawImage(kf,ar,vr);break;case"off":y.drawImage(df,ar,vr)}ku&&y.drawImage(ur,0,0),li=!1},this.repaint(),this},ci=function(n,t){t=t||{};var l=undefined===t.width?0:t.width,a=undefined===t.height?0:t.height,v=undefined===t.lcdColor?steelseries.LcdColor.STANDARD:t.lcdColor,bt=undefined===t.lcdDecimals?2:t.lcdDecimals,tt=undefined===t.unitString?"":t.unitString,ut=undefined===t.unitStringVisible?!1:t.unitStringVisible,dt=undefined===t.headerString?"":t.headerString,ft=undefined===t.headerStringVisible?!1:t.headerStringVisible,et=undefined===t.digitalFont?!1:t.digitalFont,gt=undefined===t.valuesNumeric?!0:t.valuesNumeric,y=undefined===t.value?0:t.value,ni=undefined===t.alwaysScroll?!1:t.alwaysScroll,ht=undefined===t.autoScroll?!1:t.autoScroll,u=undefined===t.section?null:t.section,c=!1,o=0,k,d=!1,ti=this,i=p.getElementById(n).getContext("2d");l===0&&(l=i.canvas.width),a===0&&(a=i.canvas.height),i.canvas.width=l,i.canvas.height=a;var e=l,f=a,h=0,w=Math.floor(f/1.5),ct=w+"px "+s,lt=w+"px "+pt,at=!1,vt,yt=[],wt=[],ii=function(n,t){var l,a,r;i.save(),i.textAlign="right",i.strokeStyle=t,i.fillStyle=t,i.beginPath(),i.rect(2,0,e-4,f),i.closePath(),i.clip(),(v===steelseries.LcdColor.STANDARD||v===steelseries.LcdColor.STANDARD_GREEN)&&u===null&&(i.shadowColor="gray",i.shadowOffsetX=f*.035,i.shadowOffsetY=f*.035,i.shadowBlur=f*.055),i.font=et?lt:ct,gt?(l=0,h=0,ut&&(i.font=Math.floor(f/2.5)+"px "+s,l=i.measureText(tt).width),i.font=et?lt:ct,a=n.toFixed(bt),h=i.measureText(a).width,r=.38,ft&&(r=.52),i.fillText(a,e-l-4-o,f*.5+w*r),ut&&(i.font=Math.floor(f/2.5)+"px "+s,i.fillText(tt,e-2-o,f*.5+w*r)),ft&&(i.textAlign="center",i.font=Math.floor(f/3.5)+"px "+s,i.fillText(dt,e/2,f*.3))):(h=i.measureText(n).width,ni||ht&&h>e-4?c||(o=h>e*.8?e-h-e*.2:0,c=!0,clearTimeout(k),k=setTimeout(g,200)):ht&&h<=e-4&&(o=0,c=!1),i.fillText(n,e-2-o,f*.5+w*.38)),i.restore()},ri=function(n,t,i,u){var tt=r(n,t),f=tt.getContext("2d");f.save();var h=0,et=n,it=t,ut=Math.min(n,t)*.095,s=f.createLinearGradient(0,h,0,h+it);s.addColorStop(0,"#4c4c4c"),s.addColorStop(.08,"#666666"),s.addColorStop(.92,"#666666"),s.addColorStop(1,"#e6e6e6"),f.fillStyle=s,kt(f,0,h,et,it,ut),f.fill(),f.restore(),f.save();var c=rt(i),e=ot(c[0],c[1],c[2]),l=rt(u.gradientStartColor),ht=ot(l[0],l[1],l[2]),a=rt(u.gradientFraction1Color),ct=ot(a[0],a[1],a[2]),v=rt(u.gradientFraction2Color),lt=ot(v[0],v[1],v[2]),y=rt(u.gradientFraction3Color),at=ot(y[0],y[1],y[2]),p=rt(u.gradientStopColor),vt=ot(p[0],p[1],p[2]),w=st(e[0],e[1],ht[2]-.31),b=st(e[0],e[1],ct[2]-.31),k=st(e[0],e[1],lt[2]-.31),d=st(e[0],e[1],at[2]-.31),g=st(e[0],e[1],vt[2]-.31),nt=1,yt=n-2,ft=t-2,pt=ut-1,o=f.createLinearGradient(0,nt,0,nt+ft);return o.addColorStop(0,"rgb("+w[0]+", "+w[1]+", "+w[2]+")"),o.addColorStop(.03,"rgb("+b[0]+","+b[1]+","+b[2]+")"),o.addColorStop(.49,"rgb("+k[0]+","+k[1]+","+k[2]+")"),o.addColorStop(.5,"rgb("+d[0]+","+d[1]+","+d[2]+")"),o.addColorStop(1,"rgb("+g[0]+","+g[1]+","+g[2]+")"),f.fillStyle=o,kt(f,1,nt,yt,ft,pt),f.fill(),f.restore(),tt},ui=function(n){var t=rt(n),r=ot(t[0],t[1],t[2]),i=st(r[0],.57,.83);return"rgb("+i[0]+", "+i[1]+", "+i[2]+")"},g=function(){c?(o>e&&(o=-h),o+=2,k=setTimeout(g,50)):o=0,d||(d=!0,b(ti.repaint))},nt=function(){var n;if(at=!0,vt=it(l,a,v),null!==u&&0<u.length)for(n=0;n<u.length;n++)yt[n]=ri(l,a,u[n].color,v),wt[n]=ui(u[n].color)};return this.setValue=function(n){return y!==n&&(y=n,this.repaint()),this},this.setLcdColor=function(n){return v=n,nt(),this.repaint(),this},this.setSection=function(n){return u=n,nt({background:!0,foreground:!0}),this.repaint(),this},this.setScrolling=function(n){if(n){if(c)return;c=n,g()}else c=n;return this},this.repaint=function(){at||nt(),i.clearRect(0,0,i.canvas.width,i.canvas.height);var t=vt,r=v.textColor,n;if(null!==u&&0<u.length)for(n=0;n<u.length;n++)if(y>=u[n].start&&y<=u[n].stop){t=yt[n],r=wt[n];break}i.drawImage(t,0,0),ii(y,r),d=!1},this.repaint(),this},li=function(n,u){u=u||{};var o=undefined===u.size?0:u.size,hi=undefined===u.frameDesign?steelseries.FrameDesign.METAL:u.frameDesign,ci=undefined===u.frameVisible?!0:u.frameVisible,k=undefined===u.backgroundColor?steelseries.BackgroundColor.DARK_GRAY:u.backgroundColor,li=undefined===u.backgroundVisible?!0:u.backgroundVisible,dt=undefined===u.pointerTypeLatest?steelseries.PointerType.TYPE1:u.pointerTypeLatest,ai=undefined===u.pointerTypeAverage?steelseries.PointerType.TYPE8:u.pointerTypeAverage,ii=undefined===u.pointerColor?steelseries.ColorDef.RED:u.pointerColor,ri=undefined===u.pointerColorAverage?steelseries.ColorDef.BLUE:u.pointerColorAverage,ar=undefined===u.knobType?steelseries.KnobType.STANDARD_KNOB:u.knobType,vr=undefined===u.knobStyle?steelseries.KnobStyle.SILVER:u.knobStyle,vi=undefined===u.foregroundType?steelseries.ForegroundType.TYPE1:u.foregroundType,pi=undefined===u.foregroundVisible?!0:u.foregroundVisible,h=undefined===u.pointSymbols?["N","NE","E","SE","S","SW","W","NW"]:u.pointSymbols,yr=undefined===u.pointSymbolsVisible?!0:u.pointSymbolsVisible,pr=undefined===u.customLayer?null:u.customLayer,wr=undefined===u.degreeScale?!0:u.degreeScale,ui=undefined===u.degreeScaleHalf?!1:u.degreeScaleHalf,wi=undefined===u.roseVisible?!1:u.roseVisible,ht=undefined===u.lcdColor?steelseries.LcdColor.STANDARD:u.lcdColor,bi=undefined===u.lcdVisible?!0:u.lcdVisible,br=undefined===u.digitalFont?!1:u.digitalFont,ot=undefined===u.section?null:u.section,st=undefined===u.area?null:u.area,gt=undefined===u.lcdTitleStrings?["Latest","Average"]:u.lcdTitleStrings,ki=undefined===u.titleString?"":u.titleString,di=undefined===u.useColorLabels?!1:u.useColorLabels,ni=undefined===u.fullScaleDeflectionTime?2.5:u.fullScaleDeflectionTime,ct,lt,d=0,rt=0,at=c,gi=this.valueLatest,fi=this.valueAverage,kr=-i,nr=t,tr=360,et=!1,e=p.getElementById(n).getContext("2d");o===0&&(o=Math.min(e.canvas.width,e.canvas.height)),e.canvas.width=o,e.canvas.height=o;var f=o,a=o,v=f/2,y=a/2,ei=Math.floor(f/10),dr=ei+"px "+s,gr=ei+"px "+pt,ti=f*.3,ir=a*.12,rr=(f-ti)/2,ur=a*.32,fr=a*.565,er=!1,vt=r(o,o),ut=vt.getContext("2d"),si,yt=r(o,o),or=yt.getContext("2d"),bt=r(o,o),sr=bt.getContext("2d"),kt=r(o,o),hr=kt.getContext("2d"),cr=function(n,t){for(e.save(),e.textAlign="center",e.strokeStyle=ht.textColor,e.fillStyle=ht.textColor;n<-180;)n+=360;!ui&&n<0&&(n+=360),ui&&n>180&&(n=-(360-n)),n>=0?(n="00"+Math.round(n),n=n.substring(n.length,n.length-3)):(n="00"+Math.abs(Math.round(n)),n="-"+n.substring(n.length,n.length-3)),(ht===steelseries.LcdColor.STANDARD||ht===steelseries.LcdColor.STANDARD_GREEN)&&(e.shadowColor="gray",e.shadowOffsetX=f*.007,e.shadowOffsetY=f*.007,e.shadowBlur=f*.007),e.font=br?gr:dr,e.fillText(n+"\u00b0",f/2+ti*.05,(t?ur:fr)+ir*.5+ei*.38,ti*.9),e.restore()},lr=function(n,t,i,r,u){n.save(),n.strokeStyle=r,n.fillStyle=r,n.lineWidth=f*.035;var e=nr/tr*t,o=e+(i-t)/(tr/nr);n.translate(v,y),n.rotate(kr),n.beginPath(),u?(n.moveTo(0,0),n.arc(0,0,f*.365-n.lineWidth/2,e,o,!1)):n.arc(0,0,f*.365,e,o,!1),u?(n.moveTo(0,0),n.fill()):n.stroke(),n.translate(-v,-y),n.restore()},nu=function(n){var l=f*.38,a=f*.35,b=f*.36,c=f*.1,p=f*.31,u=f*.36,r,e,t,o,w;if(n.textAlign="center",n.textBaseline="middle",n.save(),n.strokeStyle=k.labelColor.getRgbaColor(),n.fillStyle=k.labelColor.getRgbaColor(),n.translate(v,y),wr)for(r=Math.floor(.1*f)+"px serif bold",e=Math.floor(f*.04)+"px "+s,n.rotate(at*5),t=5;360>=t;t+=5){if(n.save(),yr)switch(t){case 360:n.translate(u,0),n.rotate(i),n.font=r,n.fillText(h[2],0,0,c),n.translate(-u,0);break;case 90:n.translate(u,0),n.rotate(i),n.font=r,n.fillText(h[4],0,0,c),n.translate(-u,0);break;case 180:n.translate(u,0),n.rotate(i),n.font=r,n.fillText(h[6],0,0,c),n.translate(-u,0);break;case 270:n.translate(u,0),n.rotate(i),n.font=r,n.fillText(h[0],0,0,c),n.translate(-u,0);break;case 5:case 85:case 95:case 175:case 185:case 265:case 275:case 355:break;default:(t+90)%20?(n.lineWidth=(t+90)%5?1.5:1,n.beginPath(),n.moveTo(l,0),w=(t+90)%10?b:a,n.lineTo(w,0),n.closePath(),n.stroke()):(n.lineWidth=1.5,n.beginPath(),n.moveTo(l,0),n.lineTo(a,0),n.closePath(),n.stroke(),o=(t+90)%360,n.translate(p,0),n.rotate(i),n.font=e,n.fillText("0".substring(o>=100)+o,0,0,c),n.translate(-p,0))}else(t+90)%20?(n.lineWidth=(t+90)%5?1.5:1,n.beginPath(),n.moveTo(l,0),w=(t+90)%10?b:a,n.lineTo(w,0),n.closePath(),n.stroke()):(n.lineWidth=1.5,n.beginPath(),n.moveTo(l,0),n.lineTo(a,0),n.closePath(),n.stroke(),o=(t+90)%360,ui&&o>180&&(o=-(360-o)),n.translate(p,0),n.rotate(i),n.font=e,n.fillText(o,0,0,c),n.translate(-p,0));n.restore(),n.rotate(at*5)}else for(r=.12*f+"px serif",e=.06*f+"px serif",n.lineWidth=1,n.strokeStyle=k.symbolColor.getRgbaColor(),t=0;360>t;t+=2.5){0==t%5&&(n.beginPath(),n.moveTo(f*.38,0),n.lineTo(f*.36,0),n.closePath(),n.stroke()),n.save();switch(t){case 0:n.translate(f*.35,0),n.rotate(i),n.font=r,n.fillText(h[2],0,0),n.translate(-f*.35,0);break;case 45:n.translate(f*.29,0),n.rotate(i),n.font=e,n.fillText(h[3],0,0),n.translate(-f*.29,0);break;case 90:n.translate(f*.35,0),n.rotate(i),n.font=r,n.fillText(h[4],0,0),n.translate(-f*.35,0);break;case 135:n.translate(f*.29,0),n.rotate(i),n.font=e,n.fillText(h[5],0,0),n.translate(-f*.29,0);break;case 180:n.translate(f*.35,0),n.rotate(i),n.font=r,n.fillText(h[6],0,0),n.translate(-f*.35,0);break;case 225:n.translate(f*.29,0),n.rotate(i),n.font=e,n.fillText(h[7],0,0),n.translate(-f*.29,0);break;case 270:n.translate(f*.35,0),n.rotate(i),n.font=r,n.fillText(h[0],0,0),n.translate(-f*.35,0);break;case 315:n.translate(f*.29,0),n.rotate(i),n.font=e,n.fillText(h[1],0,0),n.translate(-f*.29,0)}n.restore(),wi&&(0===t||22.5===t||45===t||67.5===t||90===t||112.5===t||135===t||157.5===t||180===t||202.5===t||225===t||247.5===t||270===t||292.5===t||315===t||337.5===t||360===t)&&(n.save(),n.beginPath(),t%45?n.moveTo(f*.29,0):n.moveTo(f*.38,0),n.lineTo(f*.1,0),n.closePath(),n.restore(),n.stroke()),n.rotate(at*2.5)}n.translate(-v,-y),n.restore()},tu=function(n){gt.length>0&&(n.save(),n.textAlign="center",n.textBaseline="middle",n.fillStyle=di?ii.medium.getRgbaColor():k.labelColor.getRgbaColor(),n.font=.04*f+"px "+s,n.fillText(gt[0],f/2,a*.29,f*.3),n.fillStyle=di?ri.medium.getRgbaColor():k.labelColor.getRgbaColor(),n.fillText(gt[1],f/2,a*.71,f*.3),ki.length>0&&(n.fillStyle=k.labelColor.getRgbaColor(),n.font=.0467*f+"px "+s,n.fillText(ki,f/2,a*.5,f*.3)))},l=function(n){var t,i,u;n=n||{};var r=undefined===n.background?!1:n.background,e=undefined===n.pointer?!1:n.pointer,o=undefined===n.foreground?!1:n.foreground;if(er=!0,r&&ci&&g(ut,hi,v,y,f,a),r&&li){if(nt(ut,k,v,y,f,a),wt(ut,pr,v,y,f,a),null!==ot&&0<ot.length){t=ot.length;do t--,lr(ut,ot[t].start,ot[t].stop,ot[t].color,!1);while(0<t)}if(null!==st&&0<st.length){i=st.length;do i--,lr(ut,st[i].start,st[i].stop,st[i].color,!0);while(0<i)}nu(ut)}r&&wi&&yi(ut,v,y,f,a,k),r&&bi&&(si=it(ti,ir,ht),ut.drawImage(si,rr,ur),ut.drawImage(si,rr,fr),tu(ut)),e&&(ft(sr,f,ai,ri,k.labelColor),ft(or,f,dt,ii,k.labelColor)),o&&pi&&(u=dt.type==="type15"||dt.type==="type16"?!1:!0,tt(hr,vi,f,a,u,ar,vr))},w=function(n){n=n||{};var t=undefined===n.background?!1:n.background,i=undefined===n.pointer?!1:n.pointer,r=undefined===n.foreground?!1:n.foreground;t&&(vt.width=o,vt.height=o,ut=vt.getContext("2d")),i&&(yt.width=o,yt.height=o,or=yt.getContext("2d"),bt.width=o,bt.height=o,sr=bt.getContext("2d")),r&&(kt.width=o,kt.height=o,hr=kt.getContext("2d"))};return this.setValueLatest=function(n){return n=parseFloat(n),n=n===360?360:n%360,d!==n&&(d=n,this.repaint()),this},this.getValueLatest=function(){return d},this.setValueAverage=function(n){return n=parseFloat(n),n=n===360?360:n%360,rt!==n&&(rt=n,this.repaint()),this},this.getValueAverage=function(){return rt},this.setValueAnimatedLatest=function(n){var t,u=this,i,r;return n=parseFloat(n),t=n===360?360:n%360,d!==t&&(undefined!==ct&&ct.isPlaying&&ct.stop(),i=oi(d,t),i!==0?(r=ni*Math.abs(i)/180,r=Math.max(r,ni/5),ct=new Tween({},"",Tween.regularEaseInOut,d,d+i,r),ct.onMotionChanged=function(n){d=n.target._pos===360?360:n.target._pos%360,et||(et=!0,b(u.repaint))},ct.start()):(d=t,et||(et=!0,b(u.repaint)))),this},this.setValueAnimatedAverage=function(n){var r,u=this,t,i;return n=parseFloat(n),r=n===360?360:n%360,rt!==n&&(undefined!==lt&&lt.isPlaying&&lt.stop(),t=oi(rt,r),t!==0?(i=ni*Math.abs(t)/180,i=Math.max(i,ni/5),lt=new Tween({},"",Tween.regularEaseInOut,rt,rt+t,i),lt.onMotionChanged=function(n){rt=n.target._pos===360?360:n.target._pos%360,et||(et=!0,b(u.repaint))},lt.start()):(rt=r,et||(et=!0,b(u.repaint)))),this},this.setArea=function(n){return st=n,w({background:!0}),l({background:!0}),this.repaint(),this},this.setSection=function(n){return ot=n,w({background:!0}),l({background:!0}),this.repaint(),this},this.setFrameDesign=function(n){return hi=n,w({background:!0}),l({background:!0}),this.repaint(),this},this.setBackgroundColor=function(n){return k=n,w({background:!0}),l({background:!0}),this.repaint(),this},this.setForegroundType=function(n){return w({foreground:!0}),vi=n,l({foreground:!0}),this.repaint(),this},this.setPointerColor=function(n){return w({pointer:!0}),ii=n,l({pointer:!0}),this.repaint(),this},this.setPointerColorAverage=function(n){return w({pointer:!0}),ri=n,l({pointer:!0}),this.repaint(),this},this.setPointerType=function(n){return dt=n,w({pointer:!0,foreground:!0}),l({pointer:!0,foreground:!0}),this.repaint(),this},this.setPointerTypeAverage=function(n){return ai=n,w({pointer:!0,foreground:!0}),l({pointer:!0,foreground:!0}),this.repaint(),this},this.setPointSymbols=function(n){return h=n,w({background:!0}),l({background:!0}),this.repaint(),this},this.setLcdColor=function(n){return ht=n,w({background:!0}),l({background:!0}),this.repaint(),this},this.setLcdTitleStrings=function(n){return gt=n,w({background:!0}),l({background:!0}),this.repaint(),this},this.repaint=function(){er||l({frame:!0,background:!0,led:!0,pointer:!0,foreground:!0}),e.clearRect(0,0,e.canvas.width,e.canvas.height),(ci||li)&&e.drawImage(vt,0,0),bi&&(cr(d,!0),cr(rt,!1)),fi=rt*at;var n=f*.006;e.save(),e.translate(v,y),e.rotate(fi),e.translate(-v,-y),e.shadowColor="rgba(0, 0, 0, 0.8)",e.shadowOffsetX=e.shadowOffsetY=n,e.shadowBlur=n*2,e.drawImage(bt,0,0),gi=d*at-fi,e.translate(v,y),e.rotate(gi),e.translate(-v,-y),e.drawImage(yt,0,0),e.restore(),pi&&e.drawImage(kt,0,0),et=!1},this.repaint(),this},ai=function(n,t){var c,f,o,u,s;t=t||{};var i=undefined===t.size?0:t.size,v=undefined===t.ledColor?steelseries.LedColor.RED_LED:t.ledColor,h=!1,y=0,r=p.getElementById(n).getContext("2d");i===0&&(i=Math.min(r.canvas.width,r.canvas.height)),r.canvas.width=i,r.canvas.height=i,c=!1,f=p.createElement("canvas"),f.width=i,f.height=i,o=f.getContext("2d"),u=p.createElement("canvas"),u.width=i,u.height=i;var l=u.getContext("2d"),e=u,w=function(){c=!0,o.clearRect(0,0,o.canvas.width,o.canvas.height),o.drawImage(a(i,1,v),0,0),l.clearRect(0,0,l.canvas.width,l.canvas.height),l.drawImage(a(i,0,v),0,0)};return this.toggleLed=function(){return e=e===f?u:f,s(),this},this.setLedColor=function(n){return v=n,c=!1,s(),this},this.setLedOnOff=function(n){return e=n?f:u,s(),this},this.blink=function(n){return n?h||(y=setInterval(this.toggleLed,1e3),h=!0):h&&(clearInterval(y),h=!1,e=u),this},s=function(){c||w(),r.save(),r.clearRect(0,0,r.canvas.width,r.canvas.height),r.drawImage(e,0,0),r.restore()},s(),this},vi=function(n,t){function pt(){var t,n;for(st=!0,y.rect(0,0,c,e),t=y.createLinearGradient(0,0,0,e),t.addColorStop(0,"rgba(0, 0, 0, 1)"),t.addColorStop(.1,"rgba(0, 0, 0, 0.4)"),t.addColorStop(.33,"rgba(255, 255, 255, 0.45)"),t.addColorStop(.46,"rgba(255, 255, 255, 0)"),t.addColorStop(.9,"rgba(0, 0, 0, 0.4)"),t.addColorStop(1,"rgba(0, 0, 0, 1)"),y.fillStyle=t,y.fill(),i.rect(0,0,f,s*1.1),i.fillStyle=vt,i.fill(),i.strokeStyle="#f0f0f0",i.lineWidth="1px",i.moveTo(0,0),i.lineTo(0,s*1.1),i.stroke(),i.strokeStyle="#202020",i.moveTo(f,0),i.lineTo(f,s*1.1),i.stroke(),i.textAlign="center",i.textBaseline="middle",i.font=g,i.fillStyle=yt,n=9;n<21;n++)i.fillText(n%10,f*.5,h*(n-9)+h/2);if(l>0)for(u.rect(0,0,f,s*1.1),u.fillStyle=ct,u.fill(),u.strokeStyle="#f0f0f0",u.lineWidth="1px",u.moveTo(0,0),u.lineTo(0,s*1.1),u.stroke(),u.strokeStyle="#202020",u.moveTo(f,0),u.lineTo(f,s*1.1),u.stroke(),u.textAlign="center",u.textBaseline="middle",u.font=g,u.fillStyle=lt,n=9;n<21;n++)u.fillText(n%10,f*.5,h*(n-9)+h/2);for(n=0;n<w+l;n++)tt[n]=Math.random()*ot*e-ot*e/2}function wt(){for(var u=1,e=o,i,t,r,s,n=0;n<l;n++)e*=10;for(t=Math.floor(e),r=e-t,t=String(t),s=9,n=0;n<l+w;n++)i=+t.substring(t.length-n-1,t.length-n)||0,s!==9&&(r=0),n<l?p.drawImage(ft,c-f*u,-(h*(i+r)+nt+tt[n])):p.drawImage(ut,c-f*u,-(h*(i+r)+nt+tt[n])),u++,s=i}t=t||{};var ht=document,et=undefined===t._context?null:t._context,e=undefined===t.height?0:t.height,w=undefined===t.digits?6:t.digits,l=undefined===t.decimals?1:t.decimals,ct=undefined===t.decimalBackColor?"#F0F0F0":t.decimalBackColor,lt=undefined===t.decimalForeColor?"#F01010":t.decimalForeColor,at=undefined===t.font?"sans-serif":t.font,o=undefined===t.value?0:t.value,vt=undefined===t.valueBackColor?"#050505":t.valueBackColor,yt=undefined===t.valueForeColor?"#F8F8F8":t.valueForeColor,ot=undefined===t.wobbleFactor?.07:t.wobbleFactor,st=!1,a,v,k=!1,d,f,g,c,s,h,nt,tt=[],it,p,rt,y,ut,i,ft,u;v=et?et:ht.getElementById(n).getContext("2d"),e===0&&(e=v.canvas.height),o<0&&(o=0),d=Math.floor(e*.85),g="600 "+d+"px "+at,f=Math.floor(e*.68),c=f*(w+l),s=d*11,h=s/12,nt=h*.81,v.canvas.width=c,v.canvas.height=e,it=r(c,e),p=it.getContext("2d"),rt=r(c,e),y=rt.getContext("2d"),ut=r(f,s*1.1),i=ut.getContext("2d"),ft=r(f,s*1.1),u=ft.getContext("2d"),this.setValueAnimated=function(n){var t=this;return n=parseFloat(n),n<0&&(n=0),o!==n&&(undefined!==a&&a.isPlaying&&a.stop(),a=new Tween({},"",Tween.strongEaseOut,o,n,2),a.onMotionChanged=function(n){o=n.target._pos,k||(k=!0,b(t.repaint))},a.start()),this.repaint(),this},this.setValue=function(n){return o=parseFloat(n),o<0&&(o=0),this.repaint(),this},this.getValue=function(){return o},this.repaint=function(){st||pt(),wt(),p.drawImage(rt,0,0),v.drawImage(it,0,0),k=!1},this.repaint()},yi=function(n,i,r,u,f,e){var l=!0,o,s,h=e.symbolColor.getRgbaColor();for(n.save(),n.lineWidth=1,n.fillStyle=h,n.strokeStyle=h,n.translate(i,r),o=0;o<360;o+=15)l=!l,n.beginPath(),n.arc(0,0,u*.26,o*c,(o+15)*c,!1),n.arc(0,0,u*.23,(o+15)*c,o*c,!0),n.closePath(),l&&n.fill(),n.stroke();for(n.translate(-i,-r),o=0;360>=o;o+=90)n.beginPath(),n.moveTo(u*.560747,f*.584112),n.lineTo(u*.640186,f*.644859),n.lineTo(u*.584112,f*.560747),n.lineTo(u*.560747,f*.584112),n.closePath(),n.fillStyle=h,n.fill(),n.stroke(),n.beginPath(),n.moveTo(u*.523364,f*.397196),n.lineTo(u*.5,f*.196261),n.lineTo(u*.471962,f*.397196),n.lineTo(u*.523364,f*.397196),n.closePath(),s=n.createLinearGradient(.476635*u,0,.518691*u,0),s.addColorStop(0,"rgb(222, 223, 218)"),s.addColorStop(.48,"rgb(222, 223, 218)"),s.addColorStop(.49,h),s.addColorStop(1,h),n.fillStyle=s,n.fill(),n.stroke(),n.translate(i,r),n.rotate(o*c),n.translate(-i,-r);n.beginPath(),n.translate(i,r),n.arc(0,0,u*.1,0,t,!1),n.lineWidth=u*.022,n.stroke(),n.translate(-i,-r),n.restore()},ft=function(n,i,u,f,e){var c,o,s,h,l=i.toString()+u.type+f.light.getHexColor()+f.medium.getHexColor();if(!ft.cache[l]){c=r(i,i),o=c.getContext("2d");switch(u.type){case"type2":s=o.createLinearGradient(0,i*.471962,0,i*.130841),s.addColorStop(0,e.getRgbaColor()),s.addColorStop(.36,e.getRgbaColor()),s.addColorStop(.361,f.light.getRgbaColor()),s.addColorStop(1,f.light.getRgbaColor()),o.fillStyle=s,o.beginPath(),o.moveTo(i*.518691,i*.471962),o.lineTo(i*.509345,i*.462616),o.lineTo(i*.509345,i*.341121),o.lineTo(i*.504672,i*.130841),o.lineTo(i*.495327,i*.130841),o.lineTo(i*.490654,i*.341121),o.lineTo(i*.490654,i*.462616),o.lineTo(i*.481308,i*.471962),o.closePath(),o.fill();break;case"type3":o.beginPath(),o.rect(i*.495327,i*.130841,i*.009345,i*.373831),o.closePath(),o.fillStyle=f.light.getRgbaColor(),o.fill();break;case"type4":s=o.createLinearGradient(.467289*i,0,.528036*i,0),s.addColorStop(0,f.dark.getRgbaColor()),s.addColorStop(.51,f.dark.getRgbaColor()),s.addColorStop(.52,f.light.getRgbaColor()),s.addColorStop(1,f.light.getRgbaColor()),o.fillStyle=s,o.beginPath(),o.moveTo(i*.5,i*.126168),o.lineTo(i*.514018,i*.135514),o.lineTo(i*.53271,i*.5),o.lineTo(i*.523364,i*.602803),o.lineTo(i*.476635,i*.602803),o.lineTo(i*.467289,i*.5),o.lineTo(i*.485981,i*.135514),o.lineTo(i*.5,i*.126168),o.closePath(),o.fill();break;case"type5":s=o.createLinearGradient(.471962*i,0,.528036*i,0),s.addColorStop(0,f.light.getRgbaColor()),s.addColorStop(.5,f.light.getRgbaColor()),s.addColorStop(.5,f.medium.getRgbaColor()),s.addColorStop(1,f.medium.getRgbaColor()),o.fillStyle=s,o.beginPath(),o.moveTo(i*.5,i*.495327),o.lineTo(i*.528037,i*.495327),o.lineTo(i*.5,i*.149532),o.lineTo(i*.471962,i*.495327),o.lineTo(i*.5,i*.495327),o.closePath(),o.fill(),o.lineWidth=1,o.lineCap="square",o.lineJoin="miter",o.strokeStyle=f.dark.getRgbaColor(),o.stroke();break;case"type6":o.fillStyle=f.medium.getRgbaColor(),o.beginPath(),o.moveTo(i*.481308,i*.485981),o.lineTo(i*.481308,i*.392523),o.lineTo(i*.485981,i*.317757),o.lineTo(i*.495327,i*.130841),o.lineTo(i*.504672,i*.130841),o.lineTo(i*.514018,i*.317757),o.lineTo(i*.518691,i*.38785),o.lineTo(i*.518691,i*.485981),o.lineTo(i*.504672,i*.485981),o.lineTo(i*.504672,i*.38785),o.lineTo(i*.5,i*.317757),o.lineTo(i*.495327,i*.392523),o.lineTo(i*.495327,i*.485981),o.lineTo(i*.481308,i*.485981),o.closePath(),o.fill();break;case"type7":s=o.createLinearGradient(.481308*i,0,.518691*i,0),s.addColorStop(0,f.dark.getRgbaColor()),s.addColorStop(1,f.medium.getRgbaColor()),o.fillStyle=s,o.beginPath(),o.moveTo(i*.490654,i*.130841),o.lineTo(i*.481308,i*.5),o.lineTo(i*.518691,i*.5),o.lineTo(i*.504672,i*.130841),o.lineTo(i*.490654,i*.130841),o.closePath(),o.fill();break;case"type8":s=o.createLinearGradient(.471962*i,0,.528036*i,0),s.addColorStop(0,f.light.getRgbaColor()),s.addColorStop(.5,f.light.getRgbaColor()),s.addColorStop(.5,f.medium.getRgbaColor()),s.addColorStop(1,f.medium.getRgbaColor()),o.fillStyle=s,o.strokeStyle=f.dark.getRgbaColor(),o.beginPath(),o.moveTo(i*.5,i*.53271),o.lineTo(i*.53271,i*.5),o.bezierCurveTo(i*.53271,i*.5,i*.509345,i*.457943,i*.5,i*.149532),o.bezierCurveTo(i*.490654,i*.457943,i*.467289,i*.5,i*.467289,i*.5),o.lineTo(i*.5,i*.53271),o.closePath(),o.fill(),o.stroke();break;case"type9":s=o.createLinearGradient(.471962*i,0,.528036*i,0),s.addColorStop(0,"rgb(50, 50, 50)"),s.addColorStop(.5,"#666666"),s.addColorStop(1,"rgb(50, 50, 50)"),o.fillStyle=s,o.strokeStyle="#2E2E2E",o.beginPath(),o.moveTo(i*.495327,i*.233644),o.lineTo(i*.504672,i*.233644),o.lineTo(i*.514018,i*.439252),o.lineTo(i*.485981,i*.439252),o.lineTo(i*.495327,i*.233644),o.closePath(),o.moveTo(i*.490654,i*.130841),o.lineTo(i*.471962,i*.471962),o.lineTo(i*.471962,i*.528037),o.bezierCurveTo(i*.471962,i*.528037,i*.476635,i*.602803,i*.476635,i*.602803),o.bezierCurveTo(i*.476635,i*.607476,i*.481308,i*.607476,i*.5,i*.607476),o.bezierCurveTo(i*.518691,i*.607476,i*.523364,i*.607476,i*.523364,i*.602803),o.bezierCurveTo(i*.523364,i*.602803,i*.528037,i*.528037,i*.528037,i*.528037),o.lineTo(i*.528037,i*.471962),o.lineTo(i*.509345,i*.130841),o.lineTo(i*.490654,i*.130841),o.closePath(),o.fill(),o.beginPath(),o.moveTo(i*.495327,i*.219626),o.lineTo(i*.504672,i*.219626),o.lineTo(i*.504672,i*.135514),o.lineTo(i*.495327,i*.135514),o.lineTo(i*.495327,i*.219626),o.closePath(),o.fillStyle=f.medium.getRgbaColor(),o.fill();break;case"type10":o.beginPath(),o.moveTo(i*.5,i*.149532),o.bezierCurveTo(i*.5,i*.149532,i*.443925,i*.490654,i*.443925,i*.5),o.bezierCurveTo(i*.443925,i*.53271,i*.467289,i*.556074,i*.5,i*.556074),o.bezierCurveTo(i*.53271,i*.556074,i*.556074,i*.53271,i*.556074,i*.5),o.bezierCurveTo(i*.556074,i*.490654,i*.5,i*.149532,i*.5,i*.149532),o.closePath(),s=o.createLinearGradient(.471962*i,0,.528036*i,0),s.addColorStop(0,f.light.getRgbaColor()),s.addColorStop(.5,f.light.getRgbaColor()),s.addColorStop(.5,f.medium.getRgbaColor()),s.addColorStop(1,f.medium.getRgbaColor()),o.fillStyle=s,o.strokeStyle=f.medium.getRgbaColor(),o.lineWidth=1,o.lineCap="square",o.lineJoin="miter",o.fill(),o.stroke();break;case"type11":o.beginPath(),o.moveTo(.5*i,.168224*i),o.lineTo(.485981*i,.5*i),o.bezierCurveTo(.485981*i,.5*i,.481308*i,.584112*i,.5*i,.584112*i),o.bezierCurveTo(.514018*i,.584112*i,.509345*i,.5*i,.509345*i,.5*i),o.lineTo(.5*i,.168224*i),o.closePath(),s=o.createLinearGradient(0,.168224*i,0,.584112*i),s.addColorStop(0,f.medium.getRgbaColor()),s.addColorStop(1,f.dark.getRgbaColor()),o.fillStyle=s,o.strokeStyle=f.dark.getRgbaColor(),o.fill(),o.stroke();break;case"type12":o.beginPath(),o.moveTo(.5*i,.168224*i),o.lineTo(.485981*i,.5*i),o.lineTo(.5*i,.504672*i),o.lineTo(.509345*i,.5*i),o.lineTo(.5*i,.168224*i),o.closePath(),s=o.createLinearGradient(0,.168224*i,0,.504672*i),s.addColorStop(0,f.medium.getRgbaColor()),s.addColorStop(1,f.dark.getRgbaColor()),o.fillStyle=s,o.strokeStyle=f.dark.getRgbaColor(),o.fill(),o.stroke();break;case"type13":case"type14":o.beginPath(),o.moveTo(.485981*i,.168224*i),o.lineTo(.5*i,.130841*i),o.lineTo(.509345*i,.168224*i),o.lineTo(.509345*i,.509345*i),o.lineTo(.485981*i,.509345*i),o.lineTo(.485981*i,.168224*i),o.closePath(),u.type==="type13"?(s=o.createLinearGradient(0,.5*i,0,.130841*i),s.addColorStop(0,e.getRgbaColor()),s.addColorStop(.85,e.getRgbaColor()),s.addColorStop(.85,f.medium.getRgbaColor()),s.addColorStop(1,f.medium.getRgbaColor()),o.fillStyle=s):(s=o.createLinearGradient(.485981*i,0,.509345*i,0),s.addColorStop(0,f.veryDark.getRgbaColor()),s.addColorStop(.5,f.light.getRgbaColor()),s.addColorStop(1,f.veryDark.getRgbaColor()),o.fillStyle=s),o.fill();break;case"type15":case"type16":o.beginPath(),o.moveTo(i*.509345,i*.457943),o.lineTo(i*.5015,i*.13),o.lineTo(i*.4985,i*.13),o.lineTo(i*.490654,i*.457943),o.bezierCurveTo(i*.490654,i*.457943,i*.490654,i*.457943,i*.490654,i*.457943),o.bezierCurveTo(i*.471962,i*.462616,i*.457943,i*.481308,i*.457943,i*.5),o.bezierCurveTo(i*.457943,i*.518691,i*.471962,i*.537383,i*.490654,i*.542056),o.bezierCurveTo(i*.490654,i*.542056,i*.490654,i*.542056,i*.490654,i*.542056),u.type==="type15"?(o.lineTo(i*.490654,i*.57),o.bezierCurveTo(i*.46,i*.58,i*.46,i*.62,i*.490654,i*.63),o.bezierCurveTo(i*.47,i*.62,i*.48,i*.59,i*.5,i*.59),o.bezierCurveTo(i*.53,i*.59,i*.52,i*.62,i*.509345,i*.63),o.bezierCurveTo(i*.54,i*.62,i*.54,i*.58,i*.509345,i*.57),o.lineTo(i*.509345,i*.57)):(o.lineTo(i*.490654,i*.621495),o.lineTo(i*.509345,i*.621495)),o.lineTo(i*.509345,i*.542056),o.bezierCurveTo(i*.509345,i*.542056,i*.509345,i*.542056,i*.509345,i*.542056),o.bezierCurveTo(i*.528037,i*.537383,i*.542056,i*.518691,i*.542056,i*.5),o.bezierCurveTo(i*.542056,i*.481308,i*.528037,i*.462616,i*.509345,i*.457943),o.bezierCurveTo(i*.509345,i*.457943,i*.509345,i*.457943,i*.509345,i*.457943),o.closePath(),s=u.type==="type15"?o.createLinearGradient(0,0,0,i*.63):o.createLinearGradient(0,0,0,i*.621495),s.addColorStop(0,f.medium.getRgbaColor()),s.addColorStop(.388888,f.medium.getRgbaColor()),s.addColorStop(.5,f.light.getRgbaColor()),s.addColorStop(.611111,f.medium.getRgbaColor()),s.addColorStop(1,f.medium.getRgbaColor()),o.fillStyle=s,o.strokeStyle=f.dark.getRgbaColor(),o.fill(),o.stroke(),o.beginPath(),h=i*.06542/2,o.arc(i*.5,i*.5,h,0,t),s=o.createLinearGradient(i*.5-h,i*.5+h,0,i*.5+h),s.addColorStop(0,"#e6b35c"),s.addColorStop(.01,"#e6b35c"),s.addColorStop(.99,"#c48200"),s.addColorStop(1,"#c48200"),o.fillStyle=s,o.closePath(),o.fill(),o.beginPath(),h=i*.046728/2,o.arc(i*.5,i*.5,h,0,t),s=o.createRadialGradient(i*.5,i*.5,0,i*.5,i*.5,h),s.addColorStop(0,"#c5c5c5"),s.addColorStop(.19,"#c5c5c5"),s.addColorStop(.22,"#000000"),s.addColorStop(.8,"#000000"),s.addColorStop(.99,"#707070"),s.addColorStop(1,"#707070"),o.fillStyle=s,o.closePath(),o.fill();break;case"type1":default:s=o.createLinearGradient(0,i*.471962,0,i*.130841),s.addColorStop(0,f.veryDark.getRgbaColor()),s.addColorStop(.3,f.medium.getRgbaColor()),s.addColorStop(.59,f.medium.getRgbaColor()),s.addColorStop(1,f.veryDark.getRgbaColor()),o.fillStyle=s,o.beginPath(),o.moveTo(i*.518691,i*.471962),o.bezierCurveTo(i*.514018,i*.457943,i*.509345,i*.415887,i*.509345,i*.401869),o.bezierCurveTo(i*.504672,i*.383177,i*.5,i*.130841,i*.5,i*.130841),o.bezierCurveTo(i*.5,i*.130841,i*.490654,i*.383177,i*.490654,i*.397196),o.bezierCurveTo(i*.490654,i*.415887,i*.485981,i*.457943,i*.481308,i*.471962),o.bezierCurveTo(i*.471962,i*.481308,i*.467289,i*.490654,i*.467289,i*.5),o.bezierCurveTo(i*.467289,i*.518691,i*.481308,i*.53271,i*.5,i*.53271),o.bezierCurveTo(i*.518691,i*.53271,i*.53271,i*.518691,i*.53271,i*.5),o.bezierCurveTo(i*.53271,i*.490654,i*.528037,i*.481308,i*.518691,i*.471962),o.closePath(),o.fill()}ft.cache[l]=c}return n.drawImage(ft.cache[l],0,0),this},g,nt,wt,tt,l,a,it,et,w,b,e,f,v,ut,ht,at,ri,dt,k,h,ct,gt,ni,vt;ft.cache={},g=function(i,u,f,e,o,s){var p,h,c,l,a,v,y,w=o.toString()+s+u.design;if(!g.cache[w]){p=r(o,s),h=p.getContext("2d"),h.fillStyle="#848484",h.strokeStyle="rgba(132, 132, 132, 0.5)",h.beginPath(),h.arc(f,e,o/2,0,t,!0),h.closePath(),h.fill(),h.stroke(),h.beginPath(),h.arc(f,e,o*.990654/2,0,t,!0),h.closePath();switch(u.design){case"metal":c=h.createLinearGradient(0,o*.004672,0,s*.990654),c.addColorStop(0,"#fefefe"),c.addColorStop(.07,"rgb(210, 210, 210)"),c.addColorStop(.12,"rgb(179, 179, 179)"),c.addColorStop(1,"rgb(213, 213, 213)"),h.fillStyle=c,h.fill();break;case"brass":c=h.createLinearGradient(0,o*.004672,0,s*.990654),c.addColorStop(0,"rgb(249, 243, 155)"),c.addColorStop(.05,"rgb(246, 226, 101)"),c.addColorStop(.1,"rgb(240, 225, 132)"),c.addColorStop(.5,"rgb(90, 57, 22)"),c.addColorStop(.9,"rgb(249, 237, 139)"),c.addColorStop(.95,"rgb(243, 226, 108)"),c.addColorStop(1,"rgb(202, 182, 113)"),h.fillStyle=c,h.fill();break;case"steel":c=h.createLinearGradient(0,o*.004672,0,s*.990654),c.addColorStop(0,"rgb(231, 237, 237)"),c.addColorStop(.05,"rgb(189, 199, 198)"),c.addColorStop(.1,"rgb(192, 201, 200)"),c.addColorStop(.5,"rgb(23, 31, 33)"),c.addColorStop(.9,"rgb(196, 205, 204)"),c.addColorStop(.95,"rgb(194, 204, 203)"),c.addColorStop(1,"rgb(189, 201, 199)"),h.fillStyle=c,h.fill();break;case"gold":c=h.createLinearGradient(0,o*.004672,0,s*.990654),c.addColorStop(0,"rgb(255, 255, 207)"),c.addColorStop(.15,"rgb(255, 237, 96)"),c.addColorStop(.22,"rgb(254, 199, 57)"),c.addColorStop(.3,"rgb(255, 249, 203)"),c.addColorStop(.38,"rgb(255, 199, 64)"),c.addColorStop(.44,"rgb(252, 194, 60)"),c.addColorStop(.51,"rgb(255, 204, 59)"),c.addColorStop(.6,"rgb(213, 134, 29)"),c.addColorStop(.68,"rgb(255, 201, 56)"),c.addColorStop(.75,"rgb(212, 135, 29)"),c.addColorStop(1,"rgb(247, 238, 101)"),h.fillStyle=c,h.fill();break;case"anthracite":c=h.createLinearGradient(0,.004672*s,0,.995326*s),c.addColorStop(0,"rgb(118, 117, 135)"),c.addColorStop(.06,"rgb(74, 74, 82)"),c.addColorStop(.12,"rgb(50, 50, 54)"),c.addColorStop(1,"rgb(79, 79, 87)"),h.fillStyle=c,h.fill();break;case"tiltedGray":c=h.createLinearGradient(.233644*o,.084112*s,.81258*o,.910919*s),c.addColorStop(0,"#ffffff"),c.addColorStop(.07,"rgb(210, 210, 210)"),c.addColorStop(.16,"rgb(179, 179, 179)"),c.addColorStop(.33,"#ffffff"),c.addColorStop(.55,"#c5c5c5"),c.addColorStop(.79,"#ffffff"),c.addColorStop(1,"#666666"),h.fillStyle=c,h.fill();break;case"tiltedBlack":c=h.createLinearGradient(.228971*o,.079439*s,.802547*o,.898591*s),c.addColorStop(0,"#666666"),c.addColorStop(.21,"#000000"),c.addColorStop(.47,"#666666"),c.addColorStop(.99,"#000000"),c.addColorStop(1,"#000000"),h.fillStyle=c,h.fill();break;case"glossyMetal":c=h.createRadialGradient(.5*o,.5*s,0,.5*o,.5*o,.5*o),c.addColorStop(0,"rgb(207, 207, 207)"),c.addColorStop(.96,"rgb(205, 204, 205)"),c.addColorStop(1,"rgb(244, 244, 244)"),h.fillStyle=c,h.fill(),h.beginPath(),h.arc(.5*o,.5*s,.973962*o/2,0,t),h.closePath(),c=h.createLinearGradient(0,s-.971962*s,0,.971962*s),c.addColorStop(0,"rgb(249, 249, 249)"),c.addColorStop(.23,"rgb(200, 195, 191)"),c.addColorStop(.36,"#ffffff"),c.addColorStop(.59,"rgb(29, 29, 29)"),c.addColorStop(.76,"rgb(200, 194, 192)"),c.addColorStop(1,"rgb(209, 209, 209)"),h.fillStyle=c,h.fill(),h.beginPath(),h.arc(.5*o,.5*s,.869158*o/2,0,t),h.closePath(),h.fillStyle="#f6f6f6",h.fill(),h.beginPath(),h.arc(.5*o,.5*s,.85*o/2,0,t),h.closePath(),h.fillStyle="#333333",h.fill();break;case"blackMetal":v=[0,.125,.347222,.5,.680555,.875,1],y=[new n(254,254,254,1),new n(0,0,0,1),new n(153,153,153,1),new n(0,0,0,1),new n(153,153,153,1),new n(0,0,0,1),new n(254,254,254,1)],h.save(),h.arc(f,e,o*.990654/2,0,t,!0),h.clip(),l=o*.495327,a=o*.42056,c=new lt(v,y),c.fillCircle(h,f,e,a,l),h.strokeStyle="#848484",h.strokeStyle="rgba(132, 132, 132, 0.8)",h.beginPath(),h.lineWidth=o/90,h.arc(f,e,o/2,0,t,!0),h.closePath(),h.stroke(),h.restore();break;case"shinyMetal":v=[0,.125,.25,.347222,.5,.652777,.75,.875,1],y=[new n(254,254,254,1),new n(210,210,210,1),new n(179,179,179,1),new n(238,238,238,1),new n(160,160,160,1),new n(238,238,238,1),new n(179,179,179,1),new n(210,210,210,1),new n(254,254,254,1)],h.save(),h.arc(f,e,o*.990654/2,0,t,!0),h.clip(),l=o*.495327,a=o*.42056,c=new lt(v,y),c.fillCircle(h,f,e,a,l),h.strokeStyle="#848484",h.strokeStyle="rgba(132, 132, 132, 0.8)",h.beginPath(),h.lineWidth=o/90,h.arc(f,e,o/2,0,t,!0),h.closePath(),h.stroke(),h.restore();break;case"chrome":v=[0,.09,.12,.16,.25,.29,.33,.38,.48,.52,.63,.68,.8,.83,.87,.97,1],y=[new n(255,255,255,1),new n(255,255,255,1),new n(136,136,138,1),new n(164,185,190,1),new n(158,179,182,1),new n(112,112,112,1),new n(221,227,227,1),new n(155,176,179,1),new n(156,176,177,1),new n(254,255,255,1),new n(255,255,255,1),new n(156,180,180,1),new n(198,209,211,1),new n(246,248,247,1),new n(204,216,216,1),new n(164,188,190,1),new n(255,255,255,1)],h.save(),h.arc(f,e,o*.990654/2,0,t,!0),h.clip(),l=o*.495327,a=o*.42056,c=new lt(v,y),c.fillCircle(h,f,e,a,l),h.strokeStyle="#848484",h.strokeStyle="rgba(132, 132, 132, 0.8)",h.beginPath(),h.lineWidth=o/90,h.arc(f,e,o/2,0,t,!0),h.closePath(),h.stroke(),h.restore()}h.fillStyle="rgb(191, 191, 191)",h.beginPath(),h.arc(f,e,o*.841121/2,0,t,!0),h.closePath(),h.fill(),h.globalCompositeOperation="destination-out",h.beginPath(),h.arc(f,e,o*.83/2,0,t,!0),h.closePath(),h.fill(),g.cache[w]=p}return i.drawImage(g.cache[w],0,0),this},g.cache={},nt=function(i,u,f,e,o,s){var w,h,l,d,g,a=o*.831775/2,tt,it,rt,p,y,v,ut,b,k=o.toString()+s+u.name;if(!nt.cache[k]){if(w=r(o,s),h=w.getContext("2d"),h.beginPath(),h.arc(f,e,a,0,t,!0),h.closePath(),u.name==="CARBON"||u.name==="PUNCHED_SHEET"||u.name==="BRUSHED_METAL"||u.name==="BRUSHED_STAINLESS")u.name==="CARBON"&&(h.fillStyle=h.createPattern(pi,"repeat"),h.fill()),u.name==="PUNCHED_SHEET"&&(h.fillStyle=h.createPattern(wi,"repeat"),h.fill()),l=h.createLinearGradient(a,0,o-a,0),l.addColorStop(0,"rgba(0, 0, 0, 0.25)"),l.addColorStop(.5,"rgba(0, 0, 0, 0)"),l.addColorStop(1,"rgba(0, 0, 0, 0.25)"),h.fillStyle=l,h.beginPath(),h.arc(f,e,a,0,t,!0),h.closePath(),h.fill(),(u.name==="BRUSHED_METAL"||u.name==="BRUSHED_STAINLESS")&&(tt=u.name==="BRUSHED_METAL"?!0:!1,it=parseInt(u.gradientStop.getHexColor().substr(-6),16),rt=bi(it,5,.1,tt,.5),h.fillStyle=h.createPattern(rt.fill(0,0,o,s),"no-repeat"),h.fill());else if(u.name==="STAINLESS"||u.name==="TURNED"){if(d=[0,.03,.1,.14,.24,.33,.38,.5,.62,.67,.76,.81,.85,.97,1],g=[new n("#FDFDFD"),new n("#FDFDFD"),new n("#B2B2B4"),new n("#ACACAE"),new n("#FDFDFD"),new n("#8E8E8E"),new n("#8E8E8E"),new n("#FDFDFD"),new n("#8E8E8E"),new n("#8E8E8E"),new n("#FDFDFD"),new n("#ACACAE"),new n("#B2B2B4"),new n("#FDFDFD"),new n("#FDFDFD")],l=new lt(d,g),l.fillCircle(h,f,e,0,a),u.name==="TURNED"){for(p=a,y=p*.55,v=c*(500/p),h.save(),h.beginPath(),h.arc(f,e,p,0,t),h.closePath(),h.clip(),h.lineWidth=.5,ut=t-v*.3,b=0;b<ut;b+=v)h.strokeStyle="rgba(240, 240, 255, 0.25)",h.beginPath(),h.arc(f+y,e,y,0,t),h.stroke(),h.translate(f,e),h.rotate(v*.3),h.translate(-f,-e),h.strokeStyle="rgba(25, 10, 10, 0.1)",h.beginPath(),h.arc(f+y,e,y,0,t),h.stroke(),h.translate(f,e),h.rotate(v-v*.3),h.translate(-f,-e);h.restore()}}else l=h.createLinearGradient(0,o*.084112,0,a*2),l.addColorStop(0,u.gradientStart.getRgbaColor()),l.addColorStop(.4,u.gradientFraction.getRgbaColor()),l.addColorStop(1,u.gradientStop.getRgbaColor()),h.fillStyle=l,h.fill();l=h.createRadialGradient(f,e,0,f,e,a),l.addColorStop(0,"rgba(0, 0, 0, 0)"),l.addColorStop(.7,"rgba(0, 0, 0, 0)"),l.addColorStop(.71,"rgba(0, 0, 0, 0)"),l.addColorStop(.86,"rgba(0, 0, 0, 0.03)"),l.addColorStop(.92,"rgba(0, 0, 0, 0.07)"),l.addColorStop(.97,"rgba(0, 0, 0, 0.15)"),l.addColorStop(1,"rgba(0, 0, 0, 0.3)"),h.fillStyle=l,h.beginPath(),h.arc(f,e,a,0,t,!0),h.closePath(),h.fill(),nt.cache[k]=w}return i.drawImage(nt.cache[k],0,0),this},nt.cache={},wt=function(n,i,r,u,f,e){var o=f*.831775,s=e*.831775,h=(f-o)/2,c=(e-s)/2;return i!==null&&i.height>0&&i.width>0&&(n.save(),n.beginPath(),n.arc(r,u,f*.831775/2,0,t,!0),n.clip(),n.drawImage(i,h,c,o,s),n.restore()),this},tt=function(n,t,i,u,f,e,o,s,h){var b,c,v=Math.ceil(u*.084112),y=i*.5-v/2,p=u*.5-v/2,d=i*.008,a,w,k=t.type+i+u+f+(e!==undefined?e.type:"-")+(o!==undefined?o.style:"-")+(h!==undefined?h.type:"-");if(!tt.cache[k]){b=r(i,u),c=b.getContext("2d"),f&&(c.shadowColor="rgba(0, 0, 0, 0.8)",c.shadowOffsetX=c.shadowOffsetY=d,c.shadowBlur=d*2,s===steelseries.GaugeType.TYPE5?steelseries.Orientation.WEST===h?(y=i*.733644-v/2,c.drawImage(l(v,e,o),y,p)):steelseries.Orientation.EAST===h?(y=i*(1-.733644)-v/2,c.drawImage(l(v,e,o),y,p)):(p=u*.733644-v/2,c.drawImage(l(v,e,o),y,u*.6857)):c.drawImage(l(v,e,o),y,p),c.shadowOffsetX=c.shadowOffsetY=0,c.shadowBlur=0);switch(t.type){case"type2":c.beginPath(),c.moveTo(i*.135514,u*.696261),c.bezierCurveTo(i*.214953,u*.588785,i*.317757,u*.5,i*.462616,u*.425233),c.bezierCurveTo(i*.612149,u*.345794,i*.733644,u*.317757,i*.873831,u*.322429),c.bezierCurveTo(i*.766355,u*.112149,i*.528037,u*.023364,i*.313084,u*.130841),c.bezierCurveTo(i*.09813,u*.238317,i*.028037,u*.485981,i*.135514,u*.696261),c.closePath(),a=c.createLinearGradient(.313084*i,.135514*u,.495528*i,.493582*u),a.addColorStop(0,"rgba(255, 255, 255, 0.275)"),a.addColorStop(1,"rgba(255, 255, 255, 0.015)");break;case"type3":c.beginPath(),c.moveTo(i*.084112,u*.509345),c.bezierCurveTo(i*.21028,u*.556074,i*.462616,u*.560747,i*.5,u*.560747),c.bezierCurveTo(i*.537383,u*.560747,i*.794392,u*.560747,i*.915887,u*.509345),c.bezierCurveTo(i*.915887,u*.2757,i*.738317,u*.084112,i*.5,u*.084112),c.bezierCurveTo(i*.261682,u*.084112,i*.084112,u*.2757,i*.084112,u*.509345),c.closePath(),a=c.createLinearGradient(0,.093457*u,0,.556073*u),a.addColorStop(0,"rgba(255, 255, 255, 0.275)"),a.addColorStop(1,"rgba(255, 255, 255, 0.015)");break;case"type4":c.beginPath(),c.moveTo(i*.67757,u*.24299),c.bezierCurveTo(i*.771028,u*.308411,i*.822429,u*.411214,i*.813084,u*.528037),c.bezierCurveTo(i*.799065,u*.654205,i*.719626,u*.757009,i*.593457,u*.799065),c.bezierCurveTo(i*.485981,u*.831775,i*.369158,u*.808411,i*.285046,u*.728971),c.bezierCurveTo(i*.2757,u*.719626,i*.252336,u*.714953,i*.233644,u*.728971),c.bezierCurveTo(i*.214953,u*.747663,i*.219626,u*.771028,i*.228971,u*.7757),c.bezierCurveTo(i*.331775,u*.878504,i*.476635,u*.915887,i*.616822,u*.869158),c.bezierCurveTo(i*.771028,u*.822429,i*.873831,u*.691588,i*.88785,u*.53271),c.bezierCurveTo(i*.897196,u*.38785,i*.836448,u*.257009,i*.719626,u*.182242),c.bezierCurveTo(i*.705607,u*.172897,i*.682242,u*.163551,i*.663551,u*.186915),c.bezierCurveTo(i*.654205,u*.205607,i*.668224,u*.238317,i*.67757,u*.24299),c.closePath(),a=c.createRadialGradient(.5*i,.5*u,0,.5*i,.5*u,.38785*i),a.addColorStop(0,"rgba(255, 255, 255, 0)"),a.addColorStop(.82,"rgba(255, 255, 255, 0)"),a.addColorStop(.83,"rgba(255, 255, 255, 0)"),a.addColorStop(1,"rgba(255, 255, 255, 0.15)"),c.beginPath(),c.moveTo(i*.261682,u*.224299),c.bezierCurveTo(i*.285046,u*.238317,i*.252336,u*.285046,i*.24299,u*.317757),c.bezierCurveTo(i*.24299,u*.350467,i*.271028,u*.383177,i*.271028,u*.397196),c.bezierCurveTo(i*.2757,u*.415887,i*.261682,u*.457943,i*.238317,u*.509345),c.bezierCurveTo(i*.224299,u*.542056,i*.17757,u*.612149,i*.158878,u*.612149),c.bezierCurveTo(i*.144859,u*.612149,i*.088785,u*.546728,i*.130841,u*.369158),c.bezierCurveTo(i*.140186,u*.336448,i*.214953,u*.200934,i*.261682,u*.224299),c.closePath(),w=c.createLinearGradient(.130841*i,.369158*u,.273839*i,.412877*u),w.addColorStop(0,"rgba(255, 255, 255, 0.275)"),w.addColorStop(1,"rgba(255, 255, 255, 0.015)"),c.fillStyle=w,c.fill();break;case"type5":c.beginPath(),c.moveTo(i*.084112,u*.5),c.bezierCurveTo(i*.084112,u*.271028,i*.271028,u*.084112,i*.5,u*.084112),c.bezierCurveTo(i*.700934,u*.084112,i*.864485,u*.224299,i*.906542,u*.411214),c.bezierCurveTo(i*.911214,u*.439252,i*.911214,u*.518691,i*.845794,u*.537383),c.bezierCurveTo(i*.794392,u*.546728,i*.551401,u*.411214,i*.392523,u*.457943),c.bezierCurveTo(i*.168224,u*.509345,i*.135514,u*.7757,i*.093457,u*.593457),c.bezierCurveTo(i*.088785,u*.560747,i*.084112,u*.53271,i*.084112,u*.5),c.closePath(),a=c.createLinearGradient(0,.084112*u,0,.644859*u),a.addColorStop(0,"rgba(255, 255, 255, 0.275)"),a.addColorStop(1,"rgba(255, 255, 255, 0.015)");break;case"type1":default:c.beginPath(),c.moveTo(i*.084112,u*.509345),c.bezierCurveTo(i*.205607,u*.448598,i*.336448,u*.415887,i*.5,u*.415887),c.bezierCurveTo(i*.672897,u*.415887,i*.789719,u*.443925,i*.915887,u*.509345),c.bezierCurveTo(i*.915887,u*.2757,i*.738317,u*.084112,i*.5,u*.084112),c.bezierCurveTo(i*.261682,u*.084112,i*.084112,u*.2757,i*.084112,u*.509345),c.closePath(),a=c.createLinearGradient(0,.088785*u,0,.490654*u),a.addColorStop(0,"rgba(255, 255, 255, 0.275)"),a.addColorStop(1,"rgba(255, 255, 255, 0.015)")}c.fillStyle=a,c.fill(),tt.cache[k]=b}return n.drawImage(tt.cache[k],0,0),this},tt.cache={},l=function(n,i,u){var h,f,o=n/2,s=n/2,e,c=n.toString()+i.type+u.style;if(!l.cache[c]){h=r(n*1.18889,n*1.18889),f=h.getContext("2d");switch(i.type){case"metalKnob":f.beginPath(),f.moveTo(0,n*.5),f.bezierCurveTo(0,n*.222222,n*.222222,0,n*.5,0),f.bezierCurveTo(n*.777777,0,n,n*.222222,n,n*.5),f.bezierCurveTo(n,n*.777777,n*.777777,n,n*.5,n),f.bezierCurveTo(n*.222222,n,0,n*.777777,0,n*.5),f.closePath(),e=f.createLinearGradient(0,0,0,n),e.addColorStop(0,"rgb(92, 95, 101)"),e.addColorStop(.47,"rgb(46, 49, 53)"),e.addColorStop(1,"rgb(22, 23, 26)"),f.fillStyle=e,f.fill(),f.beginPath(),f.moveTo(n*.055555,n*.5),f.bezierCurveTo(n*.055555,n*.277777,n*.277777,n*.055555,n*.5,n*.055555),f.bezierCurveTo(n*.722222,n*.055555,n*.944444,n*.277777,n*.944444,n*.5),f.bezierCurveTo(n*.944444,n*.722222,n*.722222,n*.944444,n*.5,n*.944444),f.bezierCurveTo(n*.277777,n*.944444,n*.055555,n*.722222,n*.055555,n*.5),f.closePath(),e=f.createLinearGradient(0,.055555*n,0,.944443*n);switch(u.style){case"black":e.addColorStop(0,"rgb(43, 42, 47)"),e.addColorStop(1,"rgb(26, 27, 32)");break;case"brass":e.addColorStop(0,"rgb(150, 110, 54)"),e.addColorStop(1,"rgb(124, 95, 61)");break;case"silver":default:e.addColorStop(0,"rgb(204, 204, 204)"),e.addColorStop(1,"rgb(87, 92, 98)")}f.fillStyle=e,f.fill(),f.beginPath(),f.moveTo(n*.777777,n*.833333),f.bezierCurveTo(n*.722222,n*.722222,n*.611111,n*.666666,n*.5,n*.666666),f.bezierCurveTo(n*.388888,n*.666666,n*.277777,n*.722222,n*.222222,n*.833333),f.bezierCurveTo(n*.277777,n*.888888,n*.388888,n*.944444,n*.5,n*.944444),f.bezierCurveTo(n*.611111,n*.944444,n*.722222,n*.888888,n*.777777,n*.833333),f.closePath(),e=f.createRadialGradient(.555555*n,.944444*n,0,.555555*n,.944444*n,.388888*n),e.addColorStop(0,"rgba(255, 255, 255, 0.6)"),e.addColorStop(1,"rgba(255, 255, 255, 0)"),f.fillStyle=e,f.fill(),f.beginPath(),f.moveTo(n*.944444,n*.277777),f.bezierCurveTo(n*.833333,n*.111111,n*.666666,0,n*.5,0),f.bezierCurveTo(n*.333333,0,n*.166666,n*.111111,n*.055555,n*.277777),f.bezierCurveTo(n*.166666,n*.333333,n*.333333,n*.388888,n*.5,n*.388888),f.bezierCurveTo(n*.666666,n*.388888,n*.833333,n*.333333,n*.944444,n*.277777),f.closePath(),e=f.createRadialGradient(.5*n,0,0,.5*n,0,.583333*n),e.addColorStop(0,"rgba(255, 255, 255, 0.749019)"),e.addColorStop(1,"rgba(255, 255, 255, 0)"),f.fillStyle=e,f.fill(),f.beginPath(),f.moveTo(n*.277777,n*.555555),f.bezierCurveTo(n*.277777,n*.388888,n*.388888,n*.277777,n*.5,n*.277777),f.bezierCurveTo(n*.611111,n*.277777,n*.777777,n*.388888,n*.777777,n*.555555),f.bezierCurveTo(n*.777777,n*.666666,n*.611111,n*.777777,n*.5,n*.777777),f.bezierCurveTo(n*.388888,n*.777777,n*.277777,n*.666666,n*.277777,n*.555555),f.closePath(),e=f.createLinearGradient(0,.277777*n,0,.722221*n),e.addColorStop(0,"#000000"),e.addColorStop(1,"rgb(204, 204, 204)"),f.fillStyle=e,f.fill(),f.beginPath(),f.moveTo(n*.333333,n*.555555),f.bezierCurveTo(n*.333333,n*.444444,n*.388888,n*.333333,n*.5,n*.333333),f.bezierCurveTo(n*.611111,n*.333333,n*.722222,n*.444444,n*.722222,n*.555555),f.bezierCurveTo(n*.722222,n*.611111,n*.611111,n*.722222,n*.5,n*.722222),f.bezierCurveTo(n*.388888,n*.722222,n*.333333,n*.611111,n*.333333,n*.555555),f.closePath(),e=f.createLinearGradient(0,.333333*n,0,.666666*n),e.addColorStop(0,"rgb(10, 9, 1)"),e.addColorStop(1,"rgb(42, 41, 37)"),f.fillStyle=e,f.fill();break;case"standardKnob":e=f.createLinearGradient(0,0,0,n),e.addColorStop(0,"rgb(180, 180, 180)"),e.addColorStop(.46,"rgb(63, 63, 63)"),e.addColorStop(1,"rgb(40, 40, 40)"),f.fillStyle=e,f.beginPath(),f.arc(o,s,n/2,0,t,!0),f.closePath(),f.fill(),e=f.createLinearGradient(0,n-n*.77,0,n-n*.77+n*.77);switch(u.style){case"black":e.addColorStop(0,"rgb(191, 191, 191)"),e.addColorStop(.5,"rgb(45, 44, 49)"),e.addColorStop(1,"rgb(125, 126, 128)");break;case"brass":e.addColorStop(0,"rgb(223, 208, 174)"),e.addColorStop(.5,"rgb(123, 95, 63)"),e.addColorStop(1,"rgb(207, 190, 157)");break;case"silver":default:e.addColorStop(0,"rgb(215, 215, 215)"),e.addColorStop(.5,"rgb(116, 116, 116)"),e.addColorStop(1,"rgb(215, 215, 215)")}f.fillStyle=e,f.beginPath(),f.arc(o,s,n*.77/2,0,t,!0),f.closePath(),f.fill(),e=f.createRadialGradient(o,s,0,o,s,n*.77/2),e.addColorStop(0,"rgba(0, 0, 0, 0)"),e.addColorStop(.75,"rgba(0, 0, 0, 0)"),e.addColorStop(.76,"rgba(0, 0, 0, 0.01)"),e.addColorStop(1,"rgba(0, 0, 0, 0.2)"),f.fillStyle=e,f.beginPath(),f.arc(o,s,n*.77/2,0,t,!0),f.closePath(),f.fill()}l.cache[c]=h}return l.cache[c]},l.cache={},a=function(n,i,f){var c,e,s=n/2,h=n/2,o,l=n.toString()+i+f.outerColor_ON;if(!a.cache[l]){c=r(n,n),e=c.getContext("2d");switch(i){case 0:o=e.createRadialGradient(s,h,0,s,h,n*.5/2),o.addColorStop(0,f.innerColor1_OFF),o.addColorStop(.2,f.innerColor2_OFF),o.addColorStop(1,f.outerColor_OFF),e.fillStyle=o,e.beginPath(),e.arc(s,h,n*.5/2,0,t,!0),e.closePath(),e.fill(),o=e.createRadialGradient(s,h,0,s,h,n*.5/2),o.addColorStop(0,"rgba(0, 0, 0, 0)"),o.addColorStop(.8,"rgba(0, 0, 0, 0)"),o.addColorStop(1,"rgba(0, 0, 0, 0.4)"),e.fillStyle=o,e.beginPath(),e.arc(s,h,n*.5/2,0,t,!0),e.closePath(),e.fill(),o=e.createLinearGradient(0,.35*n,0,.35*n+.15*n),o.addColorStop(0,"rgba(255, 255, 255, 0.4)"),o.addColorStop(1,"rgba(255, 255, 255, 0)"),e.fillStyle=o,e.beginPath(),e.arc(s,.35*n+.2*n/2,n*.2,0,t,!0),e.closePath(),e.fill();break;case 1:o=e.createRadialGradient(s,h,0,s,h,n*.5/2),o.addColorStop(0,f.innerColor1_ON),o.addColorStop(.2,f.innerColor2_ON),o.addColorStop(1,f.outerColor_ON),e.fillStyle=o,e.beginPath(),e.arc(s,h,n*.5/2,0,t,!0),e.closePath(),e.fill(),o=e.createRadialGradient(s,h,0,s,h,n*.5/2),o.addColorStop(0,"rgba(0, 0, 0, 0)"),o.addColorStop(.8,"rgba(0, 0, 0, 0)"),o.addColorStop(1,"rgba(0, 0, 0, 0.4)"),e.fillStyle=o,e.beginPath(),e.arc(s,h,n*.5/2,0,t,!0),e.closePath(),e.fill(),o=e.createLinearGradient(0,.35*n,0,.35*n+.15*n),o.addColorStop(0,"rgba(255, 255, 255, 0.4)"),o.addColorStop(1,"rgba(255, 255, 255, 0)"),e.fillStyle=o,e.beginPath(),e.arc(s,.35*n+.2*n/2,n*.2,0,t,!0),e.closePath(),e.fill(),o=e.createRadialGradient(s,h,0,s,h,n/2),o.addColorStop(0,u(f.coronaColor,0).color),o.addColorStop(.6,u(f.coronaColor,.4).color),o.addColorStop(.7,u(f.coronaColor,.25).color),o.addColorStop(.8,u(f.coronaColor,.15).color),o.addColorStop(.85,u(f.coronaColor,.05).color),o.addColorStop(1,u(f.coronaColor,0).color),e.fillStyle=o,e.beginPath(),e.arc(s,h,n/2,0,t,!0),e.closePath(),e.fill()}a.cache[l]=c}return a.cache[l]},a.cache={},it=function(n,t,i){var e,f,o=0,v=n,c=t,l=Math.min(n,t)*.095,u,s=1,y=n-2,a=t-2,p=l-1,h=n.toString()+t+JSON.stringify(i);return it.cache[h]||(e=r(n,t),f=e.getContext("2d"),u=f.createLinearGradient(0,o,0,o+c),u.addColorStop(0,"#4c4c4c"),u.addColorStop(.08,"#666666"),u.addColorStop(.92,"#666666"),u.addColorStop(1,"#e6e6e6"),f.fillStyle=u,kt(f,0,o,v,c,l),f.fill(),u=f.createLinearGradient(0,s,0,s+a),u.addColorStop(0,i.gradientStartColor),u.addColorStop(.03,i.gradientFraction1Color),u.addColorStop(.49,i.gradientFraction2Color),u.addColorStop(.5,i.gradientFraction3Color),u.addColorStop(1,i.gradientStopColor),f.fillStyle=u,kt(f,1,s,y,a,p),f.fill(),it.cache[h]=e),it.cache[h]},it.cache={},et=function(n,t,i,r){var f,u,e=n.toString()+t+i+r;return et.cache[e]||(f=p.createElement("canvas"),u=f.getContext("2d"),f.width=n,f.height=n,u.fillStyle=t,i?(u.beginPath(),u.moveTo(n*.5,n),u.lineTo(0,0),u.lineTo(n,0),u.closePath(),u.fill()):r?(u.beginPath(),u.moveTo(n,n*.5),u.lineTo(0,0),u.lineTo(0,n),u.closePath(),u.fill()):(u.beginPath(),u.moveTo(n*.5,0),u.lineTo(n,n),u.lineTo(0,n),u.closePath(),u.fill()),et.cache[e]=f),et.cache[e]},et.cache={},w=function(n,i,f){var o=n*2,h,e,s,c=i.state+n+JSON.stringify(f),l=function(){var r=f[0];i.state==="up"?(s=e.createRadialGradient(.5*n,.2*o,0,.5*n,.2*o,.5*n),s.addColorStop(0,r.innerColor1_ON),s.addColorStop(.2,r.innerColor2_ON),s.addColorStop(1,r.outerColor_ON)):(s=e.createLinearGradient(0,0,0,.5*o),s.addColorStop(0,"#323232"),s.addColorStop(1,"#5c5c5c")),e.fillStyle=s,e.beginPath(),e.moveTo(.5*n,0),e.lineTo(n,.2*o),e.lineTo(.752*n,.2*o),e.lineTo(.752*n,.37*o),e.lineTo(.252*n,.37*o),e.lineTo(.252*n,.2*o),e.lineTo(0,.2*o),e.closePath(),e.fill(),i.state!=="up"?(e.strokeStyle="rgba(0, 0, 0, 0.4)",e.beginPath(),e.moveTo(0,.2*o),e.lineTo(.5*n,0),e.lineTo(n,.2*o),e.moveTo(.252*n,.2*o),e.lineTo(.252*n,.37*o),e.stroke(),e.strokeStyle="rgba(255, 255, 255, 0.3)",e.beginPath(),e.moveTo(.252*n,.37*o),e.lineTo(.752*n,.37*o),e.lineTo(.752*n,.2*o),e.lineTo(n,.2*o),e.stroke()):(s=e.createRadialGradient(.5*n,.2*o,0,.5*n,.2*o,.7*n),s.addColorStop(0,u(r.coronaColor,0).color),s.addColorStop(.5,u(r.coronaColor,.3).color),s.addColorStop(.7,u(r.coronaColor,.2).color),s.addColorStop(.8,u(r.coronaColor,.1).color),s.addColorStop(.85,u(r.coronaColor,.05).color),s.addColorStop(1,u(r.coronaColor,0).color),e.fillStyle=s,e.beginPath(),e.arc(.5*n,.2*o,.7*n,0,t,!0),e.closePath(),e.fill())},a=function(){var r=f[1];e.beginPath(),i.state==="steady"?(s=r.outerColor_ON,e.fillStyle=s,e.rect(.128*n,.41*o,.744*n,.074*o),e.rect(.128*n,.516*o,.744*n,.074*o),e.closePath(),e.fill()):(s=e.createLinearGradient(0,.41*o,0,.41*o+.074*o),s.addColorStop(0,"#323232"),s.addColorStop(1,"#5c5c5c"),e.fillStyle=s,e.rect(.128*n,.41*o,.744*n,.074*o),e.closePath(),e.fill(),s=e.createLinearGradient(0,.516*o,0,.516*o+.074*o),s.addColorStop(0,"#323232"),s.addColorStop(1,"#5c5c5c"),e.fillStyle=s,e.rect(.128*n,.516*o,.744*n,.074*o),e.closePath(),e.fill()),i.state!=="steady"?(e.strokeStyle="rgba(0, 0, 0, 0.4)",e.beginPath(),e.moveTo(.128*n,.41*o+.074*o),e.lineTo(.128*n,.41*o),e.lineTo(.128*n+.744*n,.41*o),e.stroke(),e.beginPath(),e.moveTo(.128*n,.516*o+.074*o),e.lineTo(.128*n,.516*o),e.lineTo(.128*n+.744*n,.516*o),e.stroke(),e.strokeStyle="rgba(255, 255, 255, 0.3)",e.beginPath(),e.moveTo(.128*n+.744*n,.41*o),e.lineTo(.128*n+.744*n,.41*o+.074*o),e.lineTo(.128*n,.41*o+.074*o),e.stroke(),e.beginPath(),e.moveTo(.128*n+.744*n,.516*o),e.lineTo(.128*n+.744*n,.516*o+.074*o),e.lineTo(.128*n,.516*o+.074*o),e.stroke()):(s=e.createRadialGradient(.5*n,.5*o,0,.5*n,.5*o,.7*n),s.addColorStop(0,u(r.coronaColor,0).color),s.addColorStop(.5,u(r.coronaColor,.3).color),s.addColorStop(.7,u(r.coronaColor,.2).color),s.addColorStop(.8,u(r.coronaColor,.1).color),s.addColorStop(.85,u(r.coronaColor,.05).color),s.addColorStop(1,u(r.coronaColor,0).color),e.fillStyle=s,e.beginPath(),e.arc(.5*n,.5*o,.7*n,0,t,!0),e.closePath(),e.fill())},v=function(){var r=f[2];i.state==="down"?(s=e.createRadialGradient(.5*n,.8*o,0,.5*n,.8*o,.5*n),s.addColorStop(0,r.innerColor1_ON),s.addColorStop(.2,r.innerColor2_ON),s.addColorStop(1,r.outerColor_ON)):(s=e.createLinearGradient(0,.63*o,0,o),s.addColorStop(0,"#323232"),s.addColorStop(1,"#5c5c5c")),e.beginPath(),e.fillStyle=s,e.moveTo(.5*n,o),e.lineTo(n,.8*o),e.lineTo(.725*n,.8*o),e.lineTo(.725*n,.63*o),e.lineTo(.252*n,.63*o),e.lineTo(.252*n,.8*o),e.lineTo(0,.8*o),e.closePath(),e.fill(),i.state!=="down"?(e.strokeStyle="rgba(0, 0, 0, 0.4)",e.beginPath(),e.moveTo(0,.8*o),e.lineTo(.252*n,.8*o),e.moveTo(.252*n,.63*o),e.lineTo(.752*n,.63*o),e.stroke(),e.beginPath(),e.moveTo(.752*n,.8*o),e.lineTo(n,.8*o),e.stroke(),e.strokeStyle="rgba(255, 255, 255, 0.3)",e.beginPath(),e.moveTo(0,.8*o),e.lineTo(.5*n,o),e.lineTo(n,.8*o),e.stroke(),e.beginPath(),e.moveTo(.752*n,.8*o),e.lineTo(.752*n,.63*o),e.stroke()):(s=e.createRadialGradient(.5*n,.8*o,0,.5*n,.8*o,.7*n),s.addColorStop(0,u(r.coronaColor,0).color),s.addColorStop(.5,u(r.coronaColor,.3).color),s.addColorStop(.7,u(r.coronaColor,.2).color),s.addColorStop(.8,u(r.coronaColor,.1).color),s.addColorStop(.85,u(r.coronaColor,.05).color),s.addColorStop(1,u(r.coronaColor,0).color),e.fillStyle=s,e.beginPath(),e.arc(.5*n,.8*o,.7*n,0,t,!0),e.closePath(),e.fill())};if(!w.cache[c]){h=r(n*2,n*4),e=h.getContext("2d"),e.translate(n*.5,n*.5);switch(i.state){case"up":v(),a(),l();break;case"steady":v(),l(),a();break;case"down":default:l(),a(),v()}w.cache[c]=h}return w.cache[c]},w.cache={};var ui=function(n,t,i,r,u,f,e,o,h,c){c=undefined===c?c=steelseries.GaugeType.TYPE1:c,n.save(),n.textAlign=o?"center":"left",n.textBaseline="middle",n.strokeStyle=f.labelColor.getRgbaColor(),n.fillStyle=f.labelColor.getRgbaColor(),o?(n.font=.046728*t+"px "+s,n.fillText(r,t/2,i*.3,t*.3),n.fillText(u,t/2,i*.38,t*.3)):e?(n.font=.1*t+"px "+s,n.save(),n.translate(.671428*t,.1375*i),n.rotate(1.570796),n.fillText(r,0,0),n.translate(-.671428*t,-.1375*i),n.restore(),n.font=.071428*t+"px "+s,h?c.type==="type2"?(n.textAlign="right",n.fillText(u,.36*t,i*.79,t*.25)):n.fillText(u,.63*t,i*.85,t*.2):(n.textAlign="center",c.type==="type2"?n.fillText(u,t/2,i*.92,t*.2):n.fillText(u,t/2,i*.89,t*.2))):(n.font=.035*t+"px "+s,n.fillText(r,t*.15,i*.25,t*.3),n.font=.025*t+"px "+s,n.fillText(u,t*.0625,i*.7,t*.07)),n.restore()},pi=ti(12,12,function(n){var u=n.canvas.width,t=n.canvas.height,f=0,r=0,i;n.save(),n.save(),n.beginPath(),n.rect(0,0,u*.5,t*.5),n.closePath(),n.restore(),i=n.createLinearGradient(0,r*t,0,.5*t+r*t),i.addColorStop(0,"rgb(35, 35, 35)"),i.addColorStop(1,"rgb(23, 23, 23)"),n.fillStyle=i,n.fill(),n.save(),n.beginPath(),n.rect(u*.083333,0,u*.333333,t*.416666),n.closePath(),n.restore(),f=.083333,r=0,i=n.createLinearGradient(0,r*t,0,.416666*t+r*t),i.addColorStop(0,"rgb(38, 38, 38)"),i.addColorStop(1,"rgb(30, 30, 30)"),n.fillStyle=i,n.fill(),n.save(),n.beginPath(),n.rect(u*.5,t*.5,u*.5,t*.5),n.closePath(),n.restore(),f=.5,r=.5,i=n.createLinearGradient(0,r*t,0,.5*t+r*t),i.addColorStop(0,"rgb(35, 35, 35)"),i.addColorStop(1,"rgb(23, 23, 23)"),n.fillStyle=i,n.fill(),n.save(),n.beginPath(),n.rect(u*.583333,t*.5,u*.333333,t*.416666),n.closePath(),n.restore(),f=.583333,r=.5,i=n.createLinearGradient(0,r*t,0,.416666*t+r*t),i.addColorStop(0,"rgb(38, 38, 38)"),i.addColorStop(1,"rgb(30, 30, 30)"),n.fillStyle=i,n.fill(),n.save(),n.beginPath(),n.rect(u*.5,0,u*.5,t*.5),n.closePath(),n.restore(),f=.5,r=0,i=n.createLinearGradient(0,r*t,0,.5*t+r*t),i.addColorStop(0,"#303030"),i.addColorStop(1,"rgb(40, 40, 40)"),n.fillStyle=i,n.fill(),n.save(),n.beginPath(),n.rect(u*.583333,t*.083333,u*.333333,t*.416666),n.closePath(),n.restore(),f=.583333,r=.083333,i=n.createLinearGradient(0,r*t,0,.416666*t+r*t),i.addColorStop(0,"rgb(53, 53, 53)"),i.addColorStop(1,"rgb(45, 45, 45)"),n.fillStyle=i,n.fill(),n.save(),n.beginPath(),n.rect(0,t*.5,u*.5,t*.5),n.closePath(),n.restore(),f=0,r=.5,i=n.createLinearGradient(0,r*t,0,.5*t+r*t),i.addColorStop(0,"#303030"),i.addColorStop(1,"#282828"),n.fillStyle=i,n.fill(),n.save(),n.beginPath(),n.rect(u*.083333,t*.583333,u*.333333,t*.416666),n.closePath(),n.restore(),f=.083333,r=.583333,i=n.createLinearGradient(0,r*t,0,.416666*t+r*t),i.addColorStop(0,"#353535"),i.addColorStop(1,"#2d2d2d"),n.fillStyle=i,n.fill(),n.restore()}),wi=ti(15,15,function(n){var i=n.canvas.width,t=n.canvas.height,r;n.save(),n.save(),n.beginPath(),n.rect(0,0,i,t),n.closePath(),n.restore(),n.fillStyle="#1D2123",n.fill(),n.save(),n.beginPath(),n.moveTo(0,t*.266666),n.bezierCurveTo(0,t*.4,i*.066666,t*.466666,i*.2,t*.466666),n.bezierCurveTo(i*.333333,t*.466666,i*.4,t*.4,i*.4,t*.266666),n.bezierCurveTo(i*.4,t*.133333,i*.333333,t*.066666,i*.2,t*.066666),n.bezierCurveTo(i*.066666,t*.066666,0,t*.133333,0,t*.266666),n.closePath(),r=n.createLinearGradient(0,.066666*t,0,.466666*t),r.addColorStop(0,"#000000"),r.addColorStop(1,"#444444"),n.fillStyle=r,n.fill(),n.save(),n.beginPath(),n.moveTo(0,t*.2),n.bezierCurveTo(0,t*.333333,i*.066666,t*.4,i*.2,t*.4),n.bezierCurveTo(i*.333333,t*.4,i*.4,t*.333333,i*.4,t*.2),n.bezierCurveTo(i*.4,t*.066666,i*.333333,0,i*.2,0),n.bezierCurveTo(i*.066666,0,0,t*.066666,0,t*.2),n.closePath(),n.fillStyle="#050506",n.fill(),n.save(),n.beginPath(),n.moveTo(i*.466666,t*.733333),n.bezierCurveTo(i*.466666,t*.866666,i*.533333,t*.933333,i*.666666,t*.933333),n.bezierCurveTo(i*.8,t*.933333,i*.866666,t*.866666,i*.866666,t*.733333),n.bezierCurveTo(i*.866666,t*.6,i*.8,t*.533333,i*.666666,t*.533333),n.bezierCurveTo(i*.533333,t*.533333,i*.466666,t*.6,i*.466666,t*.733333),n.closePath(),r=n.createLinearGradient(0,.533333*t,0,.933333*t),r.addColorStop(0,"#000000"),r.addColorStop(1,"#444444"),n.fillStyle=r,n.fill(),n.save(),n.beginPath(),n.moveTo(i*.466666,t*.666666),n.bezierCurveTo(i*.466666,t*.8,i*.533333,t*.866666,i*.666666,t*.866666),n.bezierCurveTo(i*.8,t*.866666,i*.866666,t*.8,i*.866666,t*.666666),n.bezierCurveTo(i*.866666,t*.533333,i*.8,t*.466666,i*.666666,t*.466666),n.bezierCurveTo(i*.533333,t*.466666,i*.466666,t*.533333,i*.466666,t*.666666),n.closePath(),n.fillStyle="#050506",n.fill(),n.restore()}),bi=function(n,t,i,u,f){function e(n,t){return n+=(2*Math.random()-1)*t|0,n<0?0:n>255?255:n}function s(n){return n<0?0:n>255?255:n}function h(n,t,i,r,u,f){var o,v,e,a,s,h,c,l;for(u>=i&&(u=i-1),a=1/(u*2+1),s=0,v=0;v<r;v++){for(h=c=l=0,o=0;o<u;o++)e=(s+o)*4,h+=n.data[e],c+=n.data[e+1],l+=n.data[e+2];for(o=0;o<i;o++)o>u&&(e=(s-u-1)*4,h-=n.data[e],c-=n.data[e+1],l-=n.data[e+2]),o+u<i&&(e=(s+u)*4,h+=n.data[e],c+=n.data[e+1],l+=n.data[e+2]),e=s*4,t.data[e]=h*a|0,t.data[e+1]=c*a|0,t.data[e+2]=l*a|0,t.data[e+3]=f,s++}}return this.fill=function(c,l,a,v){var k,d,nt,ot,p,b,st,g,y,ht,ct=255,lt=n>>16&255,at=n>>8&255,vt=n&255,tt=0,it=255*i,yt,pt,wt,w,rt,ut,ft,et;if(c=Math.floor(c),l=Math.floor(l),a=Math.ceil(a),v=Math.ceil(v),p=a-c,b=v-l,st=r(p,b),g=st.getContext("2d"),y=g.createImageData(p,b),ht=g.createImageData(p,b),f!==0)for(ot=[],k=0;k<p;k++)ot[k]=255*f*Math.sin(k/p*o)|0;for(nt=0;nt<b;nt++)for(t!==0&&(yt=pt=wt=0),d=0;d<p;d++)w=nt*p*4+d*4,rt=lt,ut=at,ft=vt,f!==0&&(et=ot[d],rt+=et,ut+=et,ft+=et),u?(tt=(2*Math.random()-1)*it|0,y.data[w]=s(rt+tt),y.data[w+1]=s(ut+tt),y.data[w+2]=s(ft+tt),y.data[w+3]=ct):(y.data[w]=e(rt,it),y.data[w+1]=e(ut,it),y.data[w+2]=e(ft,it),y.data[w+3]=ct);return t>0?(h(y,ht,p,b,t,ct),g.putImageData(ht,c,l)):g.putImageData(y,c,l),st},this},n=function(n,t,i,r){function s(){u=y(n,255),f=y(t,255),e=y(i,255),o=y(r,1)}var u,f,e,o;arguments.length===1?(i=parseInt(n.substr(5,2),16),t=parseInt(n.substr(3,2),16),n=parseInt(n.substr(1,2),16),r=1):arguments.length===3&&(r=1),s(),this.getRed=function(){return u},this.setRed=function(n){u=y(n,255)},this.getGreen=function(){return f},this.setGreen=function(n){f=y(n,255)},this.getBlue=function(){return e},this.setBlue=function(n){e=y(n,255)},this.getAlpha=function(){return o},this.setAlpha=function(n){o=y(n,1)},this.getRgbaColor=function(){return"rgba("+u+", "+f+", "+e+", "+o+")"},this.getRgbColor=function(){return"rgb("+u+", "+f+", "+e+")"},this.getHexColor=function(){return"#"+u.toString(16)+f.toString(16)+e.toString(16)}},lt=function(n,i){for(var f=n.length-1,u=0;u<=f;u++)n[u]=t*n[u]-o;this.fillCircle=function(t,e,o,s,h){var w,l=Math.ceil(h),c=l*2,a,tt,v,y,b,k,it,g,p,d,nt,rt;for(a=t.createImageData(c,c),tt=255,y=0;y<c;y++)for(k=l-y,it=k*k,v=0;v<c;v++)if(b=v-l,g=Math.sqrt(b*b+it),g<=l&&g>=s){for(w=Math.atan2(b,k),u=0;u<f;u++)w>=n[u]&&w<n[u+1]&&(d=bt(i[u],i[u+1],n[u+1]-n[u],w-n[u],!0));p=(c-y)*c*4+v*4,a.data[p]=d[0],a.data[p+1]=d[1],a.data[p+2]=d[2],a.data[p+3]=tt}nt=r(c,c),rt=nt.getContext("2d"),rt.putImageData(a,0,0),t.drawImage(nt,e-l,o-l)},this.fillRect=function(t,e,o,s,h,c,l){var w,k,d,y,nt,a,v,tt,it,p,b,g,rt;for(s=Math.ceil(s),h=Math.ceil(h),k=s/2,d=h/2,c=Math.ceil(c),l=Math.ceil(l),y=t.createImageData(s,h),nt=255,v=0;v<h;v++)for(it=d-v,a=0;a<s;a++){for(v>l&&v<h-l&&a>c&&a<s-c&&(a=s-c),tt=a-k,w=Math.atan2(tt,it),u=0;u<f;u++)w>=n[u]&&w<n[u+1]&&(b=bt(i[u],i[u+1],n[u+1]-n[u],w-n[u],!0));p=(h-v)*s*4+a*4,y.data[p]=b[0],y.data[p+1]=b[0],y.data[p+2]=b[0],y.data[p+3]=nt}g=r(s,h),rt=g.getContext("2d"),rt.putImageData(y,0,0),t.drawImage(g,e-k,o-d)}},ki=function(n,t,i,r){this.getColorAt=function(n){var u=0,e=0,f=1,o=1,t,s;for(n=n<0?0:n>1?1:n,t=0;t<i.length;t++){if(i[t]<n&&u<i[t]&&(u=i[t],e=t),i[t]===n)return r[t];i[t]>n&&f>=i[t]&&(f=i[t],o=t)}return s=(n-u)/(f-u),bt(r[e],r[o],1,s)},this.getStart=function(){return n},this.getEnd=function(){return t}};Math.log10=function(n){return Math.log(n)/Math.LN10},b=function(){return window.requestAnimationFrame||window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame||window.oRequestAnimationFrame||window.msRequestAnimationFrame||function(n){window.setTimeout(n,1e3/16)}}(),function(){e=function(n,t,i,r,u,f){this.gradientStart=n,this.gradientFraction=t,this.gradientStop=i,this.labelColor=r,this.symbolColor=u,this.name=f}}(),function(){f=function(n,t,i,r,u,f){this.gradientStartColor=n,this.gradientFraction1Color=t,this.gradientFraction2Color=i,this.gradientFraction3Color=r,this.gradientStopColor=u,this.textColor=f}}(),function(){v=function(n,t,i,r,u,f){this.veryDark=n,this.dark=t,this.medium=i,this.light=r,this.lighter=u,this.veryLight=f}}(),function(){ut=function(n,t,i,r,u,f,e){this.innerColor1_ON=n,this.innerColor2_ON=t,this.outerColor_ON=i,this.coronaColor=r,this.innerColor1_OFF=u,this.innerColor2_OFF=f,this.outerColor_OFF=e}}(),function(){ht=function(n){this.type=n}}(),function(){at=function(n){this.type=n}}(),function(){ri=function(n){this.type=n}}(),function(){dt=function(n){this.style=n}}(),function(){k=function(n){this.design=n}}(),function(){h=function(n){this.type=n}}(),function(){ct=function(n){this.type=n}}(),function(){gt=function(n){this.format=n}}(),function(){ni=function(n){this.type=n}}(),function(){vt=function(n){this.state=n}}();var nr={DARK_GRAY:new e(new n(0,0,0,1),new n(51,51,51,1),new n(153,153,153,1),new n(255,255,255,1),new n(180,180,180,1),"DARK_GRAY"),SATIN_GRAY:new e(new n(45,57,57,1),new n(45,57,57,1),new n(45,57,57,1),new n(167,184,180,1),new n(137,154,150,1),"SATIN_GRAY"),LIGHT_GRAY:new e(new n(130,130,130,1),new n(181,181,181,1),new n(253,253,253,1),new n(0,0,0,1),new n(80,80,80,1),"LIGHT_GRAY"),WHITE:new e(new n(255,255,255,1),new n(255,255,255,1),new n(255,255,255,1),new n(0,0,0,1),new n(80,80,80,1),"WHITE"),BLACK:new e(new n(0,0,0,1),new n(0,0,0,1),new n(0,0,0,1),new n(255,255,255,1),new n(150,150,150,1),"BLACK"),BEIGE:new e(new n(178,172,150,1),new n(204,205,184,1),new n(231,231,214,1),new n(0,0,0,1),new n(80,80,80,1),"BEIGE"),BROWN:new e(new n(245,225,193,1),new n(245,225,193,1),new n(255,250,240,1),new n(109,73,47,1),new n(89,53,27,1),"BROWN"),RED:new e(new n(198,93,95,1),new n(212,132,134,1),new n(242,218,218,1),new n(0,0,0,1),new n(90,0,0,1),"RED"),GREEN:new e(new n(65,120,40,1),new n(129,171,95,1),new n(218,237,202,1),new n(0,0,0,1),new n(0,90,0,1),"GREEN"),BLUE:new e(new n(45,83,122,1),new n(115,144,170,1),new n(227,234,238,1),new n(0,0,0,1),new n(0,0,90,1),"BLUE"),ANTHRACITE:new e(new n(50,50,54,1),new n(47,47,51,1),new n(69,69,74,1),new n(250,250,250,1),new n(180,180,180,1),"ANTHRACITE"),MUD:new e(new n(80,86,82,1),new n(70,76,72,1),new n(57,62,58,1),new n(255,255,240,1),new n(225,225,210,1),"MUD"),PUNCHED_SHEET:new e(new n(50,50,54,1),new n(47,47,51,1),new n(69,69,74,1),new n(255,255,255,1),new n(180,180,180,1),"PUNCHED_SHEET"),CARBON:new e(new n(50,50,54,1),new n(47,47,51,1),new n(69,69,74,1),new n(255,255,255,1),new n(180,180,180,1),"CARBON"),STAINLESS:new e(new n(130,130,130,1),new n(181,181,181,1),new n(253,253,253,1),new n(0,0,0,1),new n(80,80,80,1),"STAINLESS"),BRUSHED_METAL:new e(new n(50,50,54,1),new n(47,47,51,1),new n(69,69,74,1),new n(0,0,0,1),new n(80,80,80,1),"BRUSHED_METAL"),BRUSHED_STAINLESS:new e(new n(50,50,54,1),new n(47,47,51,1),new n(110,110,112,1),new n(0,0,0,1),new n(80,80,80,1),"BRUSHED_STAINLESS"),TURNED:new e(new n(130,130,130,1),new n(181,181,181,1),new n(253,253,253,1),new n(0,0,0,1),new n(80,80,80,1),"TURNED")},tr={BEIGE:new f("#c8c8b1","rgb(241, 237, 207)","rgb(234, 230, 194)","rgb(225, 220, 183)","rgb(237, 232, 191)","#000000"),BLUE:new f("#ffffff","rgb(231, 246, 255)","rgb(170, 224, 255)","rgb(136, 212, 255)","rgb(192, 232, 255)","#124564"),ORANGE:new f("#ffffff","rgb(255, 245, 225)","rgb(255, 217, 147)","rgb(255, 201, 104)","rgb(255, 227, 173)","#503700"),RED:new f("#ffffff","rgb(255, 225, 225)","rgb(253, 152, 152)","rgb(252, 114, 115)","rgb(254, 178, 178)","#4f0c0e"),YELLOW:new f("#ffffff","rgb(245, 255, 186)","rgb(210, 255, 0)","rgb(158, 205, 0)","rgb(210, 255, 0)","#405300"),WHITE:new f("#ffffff","#ffffff","rgb(241, 246, 242)","rgb(229, 239, 244)","#ffffff","#000000"),GRAY:new f("#414141","rgb(117, 117, 117)","rgb(87, 87, 87)","#414141","rgb(81, 81, 81)","#ffffff"),BLACK:new f("#414141","#666666","#333333","#000000","#333333","#cccccc"),GREEN:new f("rgb(33, 67, 67)","rgb(33, 67, 67)","rgb(29, 58, 58)","rgb(28, 57, 57)","rgb(23, 46, 46)","rgba(0, 185, 165, 255)"),BLUE2:new f("rgb(0, 68, 103)","rgb(8, 109, 165)","rgb(0, 72, 117)","rgb(0, 72, 117)","rgb(0, 68, 103)","rgb(111, 182, 228)"),BLUE_BLACK:new f("rgb(22, 125, 212)","rgb(3, 162, 254)","rgb(3, 162, 254)","rgb(3, 162, 254)","rgb(11, 172, 244)","#000000"),BLUE_DARKBLUE:new f("rgb(18, 33, 88)","rgb(18, 33, 88)","rgb(19, 30, 90)","rgb(17, 31, 94)","rgb(21, 25, 90)","rgb(23, 99, 221)"),BLUE_GRAY:new f("rgb(135, 174, 255)","rgb(101, 159, 255)","rgb(44, 93, 255)","rgb(27, 65, 254)","rgb(12, 50, 255)","#b2b4ed"),STANDARD:new f("rgb(131, 133, 119)","rgb(176, 183, 167)","rgb(165, 174, 153)","rgb(166, 175, 156)","rgb(175, 184, 165)","rgb(35, 42, 52)"),STANDARD_GREEN:new f("#ffffff","rgb(219, 230, 220)","rgb(179, 194, 178)","rgb(153, 176, 151)","rgb(114, 138, 109)","#080C06"),BLUE_BLUE:new f("rgb(100, 168, 253)","rgb(100, 168, 253)","rgb(95, 160, 250)","rgb(80, 144, 252)","rgb(74, 134, 255)","#002cbb"),RED_DARKRED:new f("rgb(72, 36, 50)","rgb(185, 111, 110)","rgb(148, 66, 72)","rgb(83, 19, 20)","rgb(7, 6, 14)","#FE8B92"),DARKBLUE:new f("rgb(14, 24, 31)","rgb(46, 105, 144)","rgb(19, 64, 96)","rgb(6, 20, 29)","rgb(8, 9, 10)","#3DB3FF"),LILA:new f("rgb(175, 164, 255)","rgb(188, 168, 253)","rgb(176, 159, 255)","rgb(174, 147, 252)","rgb(168, 136, 233)","#076148"),BLACKRED:new f("rgb(8, 12, 11)","rgb(10, 11, 13)","rgb(11, 10, 15)","rgb(7, 13, 9)","rgb(9, 13, 14)","#B50026"),DARKGREEN:new f("rgb(25, 85, 0)","rgb(47, 154, 0)","rgb(30, 101, 0)","rgb(30, 101, 0)","rgb(25, 85, 0)","#233123"),AMBER:new f("rgb(182, 71, 0)","rgb(236, 155, 25)","rgb(212, 93, 5)","rgb(212, 93, 5)","rgb(182, 71, 0)","#593A0A"),LIGHTBLUE:new f("rgb(125, 146, 184)","rgb(197, 212, 231)","rgb(138, 155, 194)","rgb(138, 155, 194)","rgb(125, 146, 184)","#090051"),SECTIONS:new f("#b2b2b2","#ffffff","#c4c4c4","#c4c4c4","#b2b2b2","#000000")},ir={RED:new v(new n(82,0,0,1),new n(158,0,19,1),new n(213,0,25,1),new n(240,82,88,1),new n(255,171,173,1),new n(255,217,218,1)),GREEN:new v(new n(8,54,4,1),new n(0,107,14,1),new n(15,148,0,1),new n(121,186,37,1),new n(190,231,141,1),new n(234,247,218,1)),BLUE:new v(new n(0,11,68,1),new n(0,73,135,1),new n(0,108,201,1),new n(0,141,242,1),new n(122,200,255,1),new n(204,236,255,1)),ORANGE:new v(new n(118,83,30,1),new n(215,67,0,1),new n(240,117,0,1),new n(255,166,0,1),new n(255,255,128,1),new n(255,247,194,1)),YELLOW:new v(new n(41,41,0,1),new n(102,102,0,1),new n(177,165,0,1),new n(255,242,0,1),new n(255,250,153,1),new n(255,252,204,1)),CYAN:new v(new n(15,109,109,1),new n(0,109,144,1),new n(0,144,191,1),new n(0,174,239,1),new n(153,223,249,1),new n(204,239,252,1)),MAGENTA:new v(new n(98,0,114,1),new n(128,24,72,1),new n(191,36,107,1),new n(255,48,143,1),new n(255,172,210,1),new n(255,214,23,1)),WHITE:new v(new n(210,210,210,1),new n(220,220,220,1),new n(235,235,235,1),new n(255,255,255,1),new n(255,255,255,1),new n(255,255,255,1)),GRAY:new v(new n(25,25,25,1),new n(51,51,51,1),new n(76,76,76,1),new n(128,128,128,1),new n(204,204,204,1),new n(243,243,243,1)),BLACK:new v(new n(0,0,0,1),new n(5,5,5,1),new n(10,10,10,1),new n(15,15,15,1),new n(20,20,20,1),new n(25,25,25,1)),RAITH:new v(new n(0,32,65,1),new n(0,65,125,1),new n(0,106,172,1),new n(130,180,214,1),new n(148,203,242,1),new n(191,229,255,1)),GREEN_LCD:new v(new n(0,55,45,1),new n(15,109,93,1),new n(0,185,165,1),new n(48,255,204,1),new n(153,255,227,1),new n(204,255,241,1)),JUG_GREEN:new v(new n(0,56,0,1),new n(32,69,36,1),new n(50,161,0,1),new n(129,206,0,1),new n(190,231,141,1),new n(234,247,218,1))},rr={RED_LED:new ut("#FF9A89","#FF9A89","#FF3300","#FF8D70","#7E1C00","#7E1C00","#641B00"),GREEN_LED:new ut("#9AFF89","#9AFF89","#59FF2A","#A5FF00","#1C7E00","#1C7E00","#1B6400"),BLUE_LED:new ut("#899AFF","#899AFF","#0033FF","#708DFF","#001C7E","#001C7E","#001B64"),ORANGE_LED:new ut("#FEA23F","#FEA23F","#FD6C00","#FD6C00","#592800","#592800","#421F00"),YELLOW_LED:new ut("#FFFF62","#FFFF62","#FFFF00","#FFFF00","#6B6D00","#6B6D00","#515300"),CYAN_LED:new ut("#00FFFF","#00FFFF","#1BC3C3","#00FFFF","#083B3B","#083B3B","#052727"),MAGENTA_LED:new ut("#D300FF","#D300FF","#8600CB","#C300FF","#38004B","#38004B","#280035")},ur={TYPE1:new ht("type1"),TYPE2:new ht("type2"),TYPE3:new ht("type3"),TYPE4:new ht("type4"),TYPE5:new ht("type5")},fr={NORTH:new at("north"),SOUTH:new at("south"),EAST:new at("east"),WEST:new at("west")},er={STANDARD_KNOB:new ri("standardKnob"),METAL_KNOB:new ri("metalKnob")},or={BLACK:new dt("black"),BRASS:new dt("brass"),SILVER:new dt("silver")},sr={BLACK_METAL:new k("blackMetal"),METAL:new k("metal"),SHINY_METAL:new k("shinyMetal"),BRASS:new k("brass"),STEEL:new k("steel"),CHROME:new k("chrome"),GOLD:new k("gold"),ANTHRACITE:new k("anthracite"),TILTED_GRAY:new k("tiltedGray"),TILTED_BLACK:new k("tiltedBlack"),GLOSSY_METAL:new k("glossyMetal")},hr={TYPE1:new h("type1"),TYPE2:new h("type2"),TYPE3:new h("type3"),TYPE4:new h("type4"),TYPE5:new h("type5"),TYPE6:new h("type6"),TYPE7:new h("type7"),TYPE8:new h("type8"),TYPE9:new h("type9"),TYPE10:new h("type10"),TYPE11:new h("type11"),TYPE12:new h("type12"),TYPE13:new h("type13"),TYPE14:new h("type14"),TYPE15:new h("type15"),TYPE16:new h("type16")},cr={TYPE1:new ct("type1"),TYPE2:new ct("type2"),TYPE3:new ct("type3"),TYPE4:new ct("type4"),TYPE5:new ct("type5")},lr={STANDARD:new gt("standard"),FRACTIONAL:new gt("fractional"),SCIENTIFIC:new gt("scientific")},ar={NORMAL:new ni("normal"),HORIZONTAL:new ni("horizontal"),TANGENT:new ni("tangent")},vr={UP:new vt("up"),STEADY:new vt("steady"),DOWN:new vt("down"),OFF:new vt("off")};return{Radial:si,RadialBargraph:hi,DisplaySingle:ci,WindDirection:li,Led:ai,Odometer:vi,drawFrame:g,drawBackground:nt,drawForeground:tt,rgbaColor:n,ConicalGradient:lt,setAlpha:u,getColorFromFraction:bt,gradientWrapper:ki,BackgroundColor:nr,LcdColor:tr,ColorDef:ir,LedColor:rr,GaugeType:ur,Orientation:fr,FrameDesign:sr,PointerType:hr,ForegroundType:cr,KnobType:er,KnobStyle:or,LabelNumberFormat:lr,TickLabelOrientation:ar,TrendState:vr,Section:di}}();
/*!*********************************************************************
TERMS OF USE - EASING EQUATIONS
Open source under the BSD License.
Copyright (c) 2001 Robert Penner
JavaScript version copyright (C) 2006 by Philippe Maegerman
All rights reserved.
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:
   * Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
   * Redistributions in binary form must reproduce the above
copyright notice, this list of conditions and the following disclaimer
in the documentation and/or other materials provided with the
distribution.
   * Neither the name of the author nor the names of contributors may
be used to endorse or promote products derived from this software
without specific prior written permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*****************************************/
function Delegate(){}Delegate.create=function(n,t){for(var r=[],u=arguments.length,i=2;i<u;i++)r[i-2]=arguments[i];return function(){var i=[].concat(arguments,r);t.apply(n,i)}};var Tween=function(n,t,i,r,u,f,e){this.init(n,t,i,r,u,f,e)},t=Tween.prototype;t.obj={},t.prop="",t.func=function(n,t,i,r){return i*n/r+t},t.begin=0,t.change=0,t.prevTime=0,t.prevPos=0,t.looping=!1,t._duration=0,t._time=0,t._pos=0,t._position=0,t._startTime=0,t._finish=0,t.name="",t.suffixe="",t._listeners=[],t.setTime=function(n){this.prevTime=this._time,n>this.getDuration()?this.looping?(this.rewind(n-this._duration),this.update(),this.broadcastMessage("onMotionLooped",{target:this,type:"onMotionLooped"})):(this._time=this._duration,this.update(),this.stop(),this.broadcastMessage("onMotionFinished",{target:this,type:"onMotionFinished"})):n<0?(this.rewind(),this.update()):(this._time=n,this.update())},t.getTime=function(){return this._time},t.setDuration=function(n){this._duration=n===null||n<=0?1e5:n},t.getDuration=function(){return this._duration},t.setPosition=function(n){this.prevPos=this._pos;var t=this.suffixe!==""?this.suffixe:"";this.obj[this.prop]=Math.round(n)+t,this._pos=n,this.broadcastMessage("onMotionChanged",{target:this,type:"onMotionChanged"})},t.getPosition=function(n){return n===undefined&&(n=this._time),this.func(n,this.begin,this.change,this._duration)},t.setFinish=function(n){this.change=n-this.begin},t.getFinish=function(){return this.begin+this.change},t.init=function(n,t,i,r,u,f,e){arguments.length&&(this._listeners=[],this.addListener(this),e&&(this.suffixe=e),this.obj=n,this.prop=t,this.begin=r,this._pos=r,this.setDuration(f),i!==null&&i!==""&&(this.func=i),this.setFinish(u))},t.start=function(){this.rewind(),this.startEnterFrame(),this.broadcastMessage("onMotionStarted",{target:this,type:"onMotionStarted"})},t.rewind=function(n){this.stop(),this._time=n===undefined?0:n,this.fixTime(),this.update()},t.fforward=function(){this._time=this._duration,this.fixTime(),this.update()},t.update=function(){this.setPosition(this.getPosition(this._time))},t.startEnterFrame=function(){this.stopEnterFrame(),this.isPlaying=!0,this.onEnterFrame()},t.onEnterFrame=function(){this.isPlaying&&(this.nextFrame(),setTimeout(Delegate.create(this,this.onEnterFrame),25))},t.nextFrame=function(){this.setTime((this.getTimer()-this._startTime)/1e3)},t.stop=function(){this.stopEnterFrame(),this.broadcastMessage("onMotionStopped",{target:this,type:"onMotionStopped"})},t.stopEnterFrame=function(){this.isPlaying=!1},t.playing=function(){return this.isPlaying},t.continueTo=function(n,t){this.begin=this._pos,this.setFinish(n),this._duration!==undefined&&this.setDuration(t),this.start()},t.resume=function(){this.fixTime(),this.startEnterFrame(),this.broadcastMessage("onMotionResumed",{target:this,type:"onMotionResumed"})},t.yoyo=function(){this.continueTo(this.begin,this._time)},t.addListener=function(n){return this.removeListener(n),this._listeners.push(n)},t.removeListener=function(n){for(var t=this._listeners,i=t.length;i--;)if(t[i]===n)return t.splice(i,1),!0;return!1},t.broadcastMessage=function(){for(var i=[],r,t=this._listeners,u=t.length,n=0;n<arguments.length;n++)i.push(arguments[n]);for(r=i.shift(),n=0;n<u;n++)t[n][r]&&t[n][r].apply(t[n],i)},t.fixTime=function(){this._startTime=this.getTimer()-this._time*1e3},t.getTimer=function(){return(new Date).getTime()-this._time},Tween.backEaseIn=function(n,t,i,r){var u=1.70158;return i*(n/=r)*n*((u+1)*n-u)+t},Tween.backEaseOut=function(n,t,i,r){var u=1.70158;return i*((n=n/r-1)*n*((u+1)*n+u)+1)+t},Tween.backEaseInOut=function(n,t,i,r){var u=1.70158;return(n/=r/2)<1?i/2*n*n*(((u*=1.525)+1)*n-u)+t:i/2*((n-=2)*n*(((u*=1.525)+1)*n+u)+2)+t},Tween.elasticEaseIn=function(n,t,i,r,u,f){var e;return n===0?t:(n/=r)==1?t+i:(f||(f=r*.3),!u||u<Math.abs(i)?(u=i,e=f/4):e=f/(2*Math.PI)*Math.asin(i/u),-(u*Math.pow(2,10*(n-=1))*Math.sin((n*r-e)*2*Math.PI/f))+t)},Tween.elasticEaseOut=function(n,t,i,r,u,f){var e;return n===0?t:(n/=r)==1?t+i:(f||(f=r*.3),!u||u<Math.abs(i)?(u=i,e=f/4):e=f/(2*Math.PI)*Math.asin(i/u),u*Math.pow(2,-10*n)*Math.sin((n*r-e)*2*Math.PI/f)+i+t)},Tween.elasticEaseInOut=function(n,t,i,r,u,f){var e;return n===0?t:(n/=r/2)==2?t+i:(f||(f=r*.3*1.5),!u||u<Math.abs(i)?(u=i,e=f/4):e=f/(2*Math.PI)*Math.asin(i/u),n<1)?-.5*u*Math.pow(2,10*(n-=1))*Math.sin((n*r-e)*2*Math.PI/f)+t:u*Math.pow(2,-10*(n-=1))*Math.sin((n*r-e)*2*Math.PI/f)*.5+i+t},Tween.bounceEaseOut=function(n,t,i,r){return(n/=r)<1/2.75?i*7.5625*n*n+t:n<2/2.75?i*(7.5625*(n-=1.5/2.75)*n+.75)+t:n<2.5/2.75?i*(7.5625*(n-=2.25/2.75)*n+.9375)+t:i*(7.5625*(n-=2.625/2.75)*n+.984375)+t},Tween.bounceEaseIn=function(n,t,i,r){return i-Tween.bounceEaseOut(r-n,0,i,r)+t},Tween.bounceEaseInOut=function(n,t,i,r){return n<r/2?Tween.bounceEaseIn(n*2,0,i,r)*.5+t:Tween.bounceEaseOut(n*2-r,0,i,r)*.5+i*.5+t},Tween.strongEaseInOut=function(n,t,i,r){return i*(n/=r)*n*n*n*n+t},Tween.regularEaseIn=function(n,t,i,r){return i*(n/=r)*n+t},Tween.regularEaseOut=function(n,t,i,r){return-i*(n/=r)*(n-2)+t},Tween.regularEaseInOut=function(n,t,i,r){return(n/=r/2)<1?i/2*n*n+t:-i/2*(--n*(n-2)-1)+t},Tween.strongEaseIn=function(n,t,i,r){return i*(n/=r)*n*n*n*n+t},Tween.strongEaseOut=function(n,t,i,r){return i*((n=n/r-1)*n*n*n*n+1)+t},Tween.strongEaseInOut=function(n,t,i,r){return(n/=r/2)<1?i/2*n*n*n*n*n+t:i/2*((n-=2)*n*n*n*n+2)+t};